-- xenos engine layer 2 tutorial sql 2
-- c2008-2011 lukas irwin
-- database_manager.module

function doload( f )
	print ("doing load ov file " .. f )
	x = loadfile ( f )
	x()
end

doload( "modules/database_manager/dirtree.lua" )
doload( "modules/database_manager/editwindow.lua" )

function init()
	print "[xenos] database manager"

	width = 854
	height = 480

	grey  = xcore.xcolour(255, 196, 196, 196)
	ltgrey = xcore.xcolour(255, 222, 222, 222)
	white = xcore.xcolour(255, 255, 255, 255)
	black = xcore.xcolour(255, 0, 0, 0)
	clear = xcore.xcolour(0, 0, 0, 0)

	sim = xcore.xsimulation ( xcore.XDT_OPENGL, width, height, 16, false, false, false  )
	sim:setWindowCaption( "Xenos Database Manager" )
	sim:setColour( grey )
	-- font = sim:getFont( "modules/default/resources/fonthaettenschweiler.bmp" )
	font_1 = sim:getFont( "modules/default/resources/font_fixedsys_10.bmp" )
	sim:setFont( font_1,  0 )-- default
	sim:setFont( font_1,  1 )
	sim:setFont( font_1,  2 )
	sim:setFont( font_1,  3 )	
	
	-- sim:setFont( font, 0 )
	-- sim:setFont( font, 1 )
	-- sim:setFont( font, 2 )
	-- sim:setFont( font, 3 )

	sim:setSkinColor( xcore.XGDC_3D_SHADOW, grey  )
	sim:setSkinColor( xcore.XGDC_3D_FACE,  grey )
	sim:setSkinColor( xcore.XGDC_3D_LIGHT,  white )
	sim:setSkinColor( xcore.XGDC_ACTIVE_BORDER,  black )
	-- sim:setSkinColor( xcore.XGDC_ACTIVE_CAPTION,  black )
	-- sim:setSkinColor( xcore.XGDC_APP_WORKSPACE, white )

	-- sim:setSkinColor( xcore.XGDC_BUTTON_TEXT,  black )
	-- sim:setSkinColor( xcore.XGDC_GRAY_TEXT,  black )
	-- sim:setSkinColor( xcore.XGDC_HIGH_LIGHT,  black )
	-- sim:setSkinColor( xcore.XGDC_HIGH_LIGHT_TEXT,  black )


	sim:setSkinColor( xcore.XGDC_INACTIVE_BORDER, black )
	sim:setSkinColor( xcore.XGDC_INACTIVE_CAPTION, grey )
	-- sim:setSkinColor( xcore.XGDC_TOOLTIP, black )
	-- sim:setSkinColor( xcore.XGDC_TOOLTIP_BACKGROUND, grey )
	sim:setSkinColor( xcore.XGDC_SCROLLBAR, grey )
	sim:setSkinColor( xcore.XGDC_WINDOW, grey )
	sim:setSkinColor( xcore.XGDC_WINDOW_SYMBOL, white )
	sim:setSkinColor( xcore.XGDC_ICON, black )
	sim:setSkinColor( xcore.XGDC_ICON_HIGH_LIGHT, black )

	-- add context menu
	print "add menu"
	contextmenu = sim:addMenu( 101 )

	print "add items"
	contextmenu:addItem(102, "File", true)  -- new Quit
	contextmenu:addItem(103, "Edit", true)  -- duplicate
	contextmenu:addItem(104, "Tools", true) -- Run Query
	contextmenu:addItem(105, "Help", true)  -- about

	print "get submenu"
	file_contextmenu = contextmenu:getSubMenu( 0, 102 )
	file_contextmenu:addItem(111, "New Database", false)
	file_contextmenu:addItem(112, "New Table", false)
	file_contextmenu:addItem(113, "New Row", false)
	file_contextmenu:addSeparator()
	file_contextmenu:addItem(115, "Quit", false)

	edit_contextmenu = contextmenu:getSubMenu( 1, 120 )
	edit_contextmenu:addItem(121, "Edit Database", false)
	edit_contextmenu:addItem(122, "Edit Table", false)
	edit_contextmenu:addItem(123, "Edit Row", false)
	edit_contextmenu:addSeparator()
	edit_contextmenu:addItem(125, "Clone", false)

	tools_contextmenu = contextmenu:getSubMenu( 2, 130 )
	tools_contextmenu:addItem(131, "Run Query", false)

	help_contextmenu = contextmenu:getSubMenu( 3, 141 )
	help_contextmenu:addItem(142, "About", false)

	-- schema to left, databases above tables 2/3
	third_height = height/3
	third_width = width/3
	x = 0
	y = 16
	listbox_db = sim:addListbox( 10, true, xcore.x2drect( x,y,third_width, third_height ) )
	listbox_tables = sim:addListbox( 11, true, xcore.x2drect( x,third_height+1,third_width, height-20 ) )

	x = third_width + 1
	table_rows = sim:addTable( 12, true, xcore.x2drect( x,y,width,height-20 ) )

	sim:bindGUI ( "button_add_pressed", 20, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_pressed", 21, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_delete_pressed", 22, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_exit_pressed", 23, xcore.XGUI_BUTTON_CLICKED )

	sim:bindGUI ( "database_changed", 10, xcore.XGUI_LISTBOX_CHANGED )
	sim:bindGUI ( "table_changed", 11, xcore.XGUI_LISTBOX_CHANGED )
	sim:bindGUI ( "row_changed", 12, xcore.XGUI_TABLE_CHANGED )
	sim:bindGUI ( "row_changed", 12, xcore.XGUI_TABLE_SELECTED_AGAIN )

	sim:bindGUI ( "file_menu_selected", 102, xcore.XGUI_MENU_ITEM_SELECTED )
	sim:bindGUI ( "edit_menu_selected", 103, xcore.XGUI_MENU_ITEM_SELECTED )
	sim:bindGUI ( "tools_menu_selected", 104, xcore.XGUI_MENU_ITEM_SELECTED )
	sim:bindGUI ( "help_menu_selected", 142, xcore.XGUI_MENU_ITEM_SELECTED )

	current_db = ""
	current_table = ""
	current_row = ""
	substate = "none"
	action = "none"
	iswindow = 0
	current_row_index = 0

	window_elements = {} -- a container for window elements
	listDB()
end

function render()
	-- print "render"
	sim:render()
end

function update()
	-- print "update"
	f = file_contextmenu:getSelected() -- this is fucked up.
	e = edit_contextmenu:getSelected() -- this is fucked up.
	if clickmenu ~= nil then c = clickmenu:getSelected() end        -- this is -really- fucked up.
	
	
	if sim:isGUI( "clickmenu_item_add_selected" ) then print "clickmenu_item_add_selected" end
	
	if sim:isGUI( "button_exit_pressed" ) then sim:destroy() end

	if sim:isGUI( "button_add_pressed" ) then addItem() end
	if sim:isGUI( "button_edit_pressed" ) then editItem() end
	if sim:isGUI( "button_delete_pressed" ) then deleteItem() end

	if sim:isGUI( "database_changed" ) then changeDB() end
	if sim:isGUI( "table_changed" ) then changeTable() end
	if sim:isGUI( "row_changed" ) then changeRow() end
	
	if sim:isGUI( "window_accept" ) then acceptAction() end
	if sim:isGUI( "window_cancel" ) then cancelAction() end
	if sim:isGUI( "window_add_element" ) then addElement() end
	
	if sim:isGUI( "item_selected" ) then
		print "item_selected"
		-- deleteItem()
		if c == 0 then
			print "add"
			addItem()
		elseif c == 1 then
			print "edit"
			editItem()
		elseif c == 2 then
			print "delete"
			deleteItem()
		end
		if clickmenu ~= nil then
			clickmenu:destroy()
			clickmenu = nil
		end
	end

	if sim:isGUI( "popup_left" ) then
		-- print "popup_left"
		if clickmenu ~= nil then
			clickmenu:destroy()
			clickmenu = nil
		end
	end

	if sim:isGUI( "file_menu_selected" ) then
		print ( "file_menu_selected; t = " .. t )
		action = "add"
		if f == 0 then
			substate = "database"
			if iswindow == 0 then addDB() end
		elseif f == 1 then
			substate = "table"
			if iswindow == 0 then addTable() end
		elseif f == 2 then
			substate = "row"
			if iswindow == 0 then addRow() end
		elseif f == 4 then
			print "quit"
			sim:destroy()
		end
	end

	if sim:isGUI( "edit_menu_selected" ) then
		print ( "edit_menu_selected; t = " .. t )
		action = "edit"
		if e == 0 then
			substate = "database"
			if iswindow == 0 then editDB() end
		elseif e == 1 then
			substate = "table"
			if iswindow == 0 then editTable() end
		elseif e == 2 then
			substate = "row"
			if iswindow == 0 then editRow() end
		elseif e == 3 then
			-- wtf?
		elseif e == 4 then
			print "clone item?"
		end
	end

	if sim:isGUI( "tools_menu_selected" ) then
		print "tools"
		if iswindow == 0 then runQuery() end
	end

	if sim:isGUI( "help_menu_selected" ) then
		print "about"
		if iswindow == 0 then showAbout() end
	end

	lp = 0
	while lp == 0 do            -- infinite loop, continues while still messeges in que.
		e = sim:getEvent()  -- get oldest event out ov que.
		if e == nil then
			-- print "no event"
			lp = 1
		else
			
			if e:getEventType() == xcore.XGUI_EVENT then
				-- print ("GUI event type :"  .. e:getGUIEventType() )
			end
			
			if e:getEventType() == xcore.XMOUSE_EVENT then
				if e:getMouseEventType() == xcore.XMOUSE_R_PRESSED_DOWN then
					rclickx = e:getMouseX()
					rclicky = e:getMouseY()
					-- print ("r_click co-ords : ".. rclickx ..", " .. rclicky )
					addMenu()
				end
			end
			sim:removeEvent()			
		end
	end
	
	sim:update()
		
	-- print "/end update"
end

function addMenu()
	print ("addMenu" )
	clickmenu = sim:addContextMenu( 201, xcore.x2drect(rclickx, rclicky, rclickx+150, rclicky+150) )
	clickmenu:addItem(211, "Add", false)
	clickmenu:addItem(212, "Edit", false)
	clickmenu:addItem(213, "Delete", false)

	sim:bindGUI ( "item_selected", 201, xcore.XGUI_MENU_ITEM_SELECTED )
	sim:bindGUI ( "popup_left", 201, xcore.XGUI_ELEMENT_LEFT  )
	
	
	print ("XGUI_MENU_ITEM_SELECTED = " .. xcore.XGUI_MENU_ITEM_SELECTED )
	print ("XGUI_TABLE_HEADER_CHANGED = " .. xcore.XGUI_TABLE_HEADER_CHANGED )
	print ("XGUI_SPINBOX_CHANGED = " .. xcore.XGUI_SPINBOX_CHANGED )
	
	
	sim:bindGUI ( "clickmenu_item_add_selected", 211, xcore.XGUI_MENU_ITEM_SELECTED )
	
end

function listDB()
	-- print ("listDB" )
	listbox_db:clear()
	for filename, attr in dirtree("modules/database_manager/resources") do
		if attr.mode == "file" then
			tmp = string.split( filename, "/" )
			i = table.getn( tmp )
			listbox_db:addItem( tmp[i] )
		end
		-- print(attr.mode, filename)
	end
end

function listTables()
	-- print ("listTables" )
	listbox_tables:clear()
	table_rows:clear()
	current_table = ""
	q = sql:exe( "SELECT name FROM sqlite_master WHERE type='table' ORDER BY name;" )
	if q ~= nil then 
		for i = 0, q:getDataCount()-1 do
			-- tmp = tmp .. ", " .. sql:getData( i )
			listbox_tables:addItem( q:getData( i ) )
		end
		sql:removeResult( q )	
	end
end

function listRows()
	-- print ("listRows" )
	table_rows:clear()
	current_row = ""

	q = sql:exe( "SELECT ROWID, * FROM " .. current_table .. " WHERE 0 = 0;" )
	tmp = ""
	if q ~= nil then 
		for i = 0, q:getHeadCount()-1 do
			if i == 0 then
				table_rows:addColumn( "Row", i )
			else
				table_rows:addColumn( q:getHead( i ), i )
			end
		end

		for i = 0, q:getRowCount()-1 do
			table_rows:addRow( i )
		end

		row = 0
		col = 0
		for i = 0, q:getDataCount()-1 do
			-- print ( "data: " .. sql:getData( i ) )
			table_rows:setCellText ( col, row, q:getData( i ) )
			-- print "a"
			row = row + 1
			if row == q:getHeadCount() then
				col = col + 1
				row = 0
			end
		end
		table_rows:setSelected( -1 )
		sql:removeResult( q )
	end
end

function showRunResults()
	-- print ("showRunResults" )
	table_rows:clear()
	current_row = ""

	tmp = ""
	for i = 0, sql:getHeadCount()-1 do
		if i == 0 then
			table_rows:addColumn( "Row", i );
		else
			table_rows:addColumn( sql:getHead( i ), i )
		end
	end

	for i = 0, sql:getRows()-1 do
		table_rows:addRow( i )
	end

	row = 0
	col = 0
	for i = 0, sql:getDataCount()-1 do
		-- print ( "data: " .. sql:getData( i ) )
		table_rows:setCellText ( col, row, sql:getData( i ) )
		-- print "a"
		row = row + 1
		if row == sql:getHeadCount() then
			col = col + 1
			row = 0
		end
	end
	table_rows:setSelected( -1 )
end

function changeDB()
	-- print ("changeDB" )
	s = listbox_db:getSelected()
	db = listbox_db:getItem( s )
	current_db = "modules/database_manager/resources/" .. db
	substate = "database"
	-- print ( "loading " .. current_db )
	sql = xcore.xsql(  current_db )
	listTables()
end

function changeTable()
	-- print ("changeTable" )
	s = listbox_tables:getSelected()
	t = listbox_tables:getItem( s )
	-- table_rows:setSelected( -1 )
	current_table = t
	substate = "table"
	listRows()
end

function changeRow()
	-- print ("changeRow" )
	s = table_rows:getSelected()
	t = table_rows:getCellText( s , 0 )
	current_row = t
	current_row_index = s
	substate = "row"
end

function addItem()
	-- print ("addItem" )
	action = "add"
	showWindow()
end

function editItem()
	-- print ("editItem" )
	action = "edit"
	showWindow()
end

function deleteItem()
	-- print ("deleteItem" )
	action = "delete"
	showWindow()
end

function showWindow()
	-- print ("showWindow" )
	-- print ("sub state : " .. substate)
	-- add a window, modal
	if iswindow == 0 then
		iswindow = 1
		if substate == "database" then
			-- what action?
			if action == "add" then
				addDB()
			elseif action == "edit" then
				editDB()
			elseif action == "delete" then
				deleteDB()
			end
		elseif substate == "table" then
			-- what action?
			if action == "add" then
				addTable()
			elseif action == "edit" then
				editTable()
			elseif action == "delete" then
				deleteTable()
			end
		elseif substate == "row" then
			-- what action?
			if action == "add" then
				addRow()
			elseif action == "edit" then
				editRow()
			elseif action == "delete" then
				deleteRow()
			end
		end
	else
		-- print "window already created?"
	end
end

function cancelAction()
	-- print ("cancelAction" )
	action = "none"
	hideWindow()
end

function acceptAction()
	-- print ("acceptAction" )
	hideWindow()
	action = "none"
end

function addDB()
	-- print "add database"
	iswindow = 1
	window = editwindow:new()
	window:addInputElement( "Database Name", "" )
	window:addButtons()
	window:setText ( "New Database" )
end

function addTable()
	-- print "add Table"
	iswindow = 1
	window = editwindow:new()
	window:addInputElement( "Table Name", "" )
	window:addDynamicElement()
	window:addDynamicElementButton()
	window:addButtons()
	window:setText ( "New Table" )
end

function addRow()
	-- print "addRow"
	iswindow = 1
	window = editwindow:new()
	-- print ( "SELECT * FROM " .. current_table .. " WHERE 0 = 0" )
	q = sql:exe( "SELECT * FROM " .. current_table .. " WHERE 0 = 0" )
	for i = 0, q:getHeadCount()-1 do
		-- table_rows:addColumn( q:getHead( i ), i );
		window:addInputElement( q:getHead( i ), "" )
	end

	window:addButtons()
	window:setText ( "New Row" )
end

function deleteDB()
	-- print "delete database"
	iswindow = 1
	window = editwindow:new()

	window:addMessage( "Are you sure you want to delete this database? This action can not be undone." )
	window:addButtons()
	window:setText ( "Delete Database" )
end

function deleteTable()
	-- print "deleteTable"
	iswindow = 1
	window = editwindow:new()

	window:addMessage( "Are you sure you want to delete this table? This action can not be undone." )
	window:addButtons()
	window:setText ( "Delete Table" )
end

function deleteRow()
	-- print "deleteRow"
	iswindow = 1
	window = editwindow:new()

	window:addMessage( "Are you sure you want to delete this row? This action can not be undone." )
	window:addButtons()
	window:setText ( "Delete Row" )
end


function editDB()
	-- print "edit database is not implemented"
	-- TODO: rename database?
	iswindow = 1
	window = editwindow:new()
	window:addInputElement( "Database Name", "N" )
	window:addButtons()
	window:setText ( "Edit Database" )
end

function editTable()
	print "edit table"
	query = "PRAGMA table_info(" .. current_table .. ")"
	print ("query:" .. query)
	sql:exe( query )

	iswindow = 1
	window = editwindow:new()

	-- print ( "SELECT * FROM " .. current_table .. " WHERE ROWID = " .. p )
	q = sql:exe( "SELECT * FROM " .. current_table .. " LIMIT 1" )

	for i = 0, q:getHeadCount()-1 do
		window:addInputElement( q:getHead( i ), q:getHead( i ) )
	end

	existing_field_count = q:getHeadCount()
	sql:removeResult( q )

	window:addDynamicElementButton()
	window:addButtons()
	window:setText ( "Edit Table" )

	-- show list ov field names, with a rename field
	-- an add field button that adds a dynamic element
	-- TODO: delete buttons (?)
end

function editRow()
	-- print "editRow"
	query = "PRAGMA table_info(" .. current_table .. ")"
	-- print ("query:" .. query)
	sql:exe( query )

	iswindow = 1
	window = editwindow:new()
	p = table_rows:getCellText ( table_rows:getSelected(), 0  )
	-- print ( "SELECT * FROM " .. current_table .. " WHERE ROWID = " .. p )
	q = sql:exe( "SELECT * FROM " .. current_table .. " WHERE ROWID = " .. p )
	if q~= nil then
		for i = 0, q:getHeadCount()-1 do
			window:addInputElement( q:getHead( i ), q:getData( i ) )
		end
	end
	sql:removeResult( q )	
	window:addButtons()
	window:setText ( "Edit Row" )
end

function addElement()
	print "addElement"
	b = 0
	while  b == 0 do
		b = window:removeButtons()
	end
	window.rows = window.rows - 2
	window:addDynamicElement()
	window:addDynamicElementButton()
	window:addButtons()
end

function showAbout()
	window = editwindow:new()
	window:addMessage( "Xenos Database Manager\nc2009 xhrit.com" )
	window:addButtons()
	window:setText ( "About" )
end

function runQuery()
	-- print "runQuery"
	window = editwindow:new()
	window:addEditBox()
	window:addButtons()
	window:setText ( "Run Query" )
	action = "run"
end

function hideWindow()
	print ("hideWindow" )
	iswindow = 0
	-- add a window
	if action == "none" then
		-- print "action = none, canceling"
		if window ~= nil then
			-- print("a")
			window:destroy()
		end
		-- print("...")
	else
		-- print ( "action " .. action )
		-- print ( "substate " .. substate )
		if substate == "database" then
			-- what action?
			if action == "add" then
				-- print "accept add database"
				a = window:getValue("Database Name")
				if a ~= "" then
					sql = xcore.xsql( "modules/database_manager/resources/" .. a )
					window:destroy()
					listDB()
				else
					-- print "null database name"
				end
			elseif action == "edit" then
				-- print "accept edit database"

			elseif action == "delete" then
				-- print ( "rm " .. "modules/database_manager/resources/" .. db )
				os.execute( "rm " .. "modules/database_manager/resources/" .. db  )
				window:destroy()
				listDB()
			elseif action == "run" then
				-- print "Run Query!"
			end
		elseif substate == "table" then
			if action == "add" then
				-- print "accept add table"
				-- TODO: copy and refactor for use as edit function
				-- 
				tn = window:getValue("Table Name")
				if  tn ~= "" then
					query = "CREATE TABLE " .. tn .. " ("
					query2 = "INSERT INTO " .. tn .. " ("
					keylist = ""
					keys, types = window:getDynamicData()
					f = window:getDynamicElementCount()
					for i = 1, f do
						-- print ( "key:"  .. keys[i] )
						-- print ( "type:"  .. types[i] )
						if types[i] == "Primary Key" then types[i] = "INTEGER PRIMARY KEY" end
						query = query .. keys[i] .. " " .. types[i]
						keylist = keylist .. keys[i]
						-- typelist = typelist
						if i < f then
 							query = query .. ", "
							keylist = keylist .. ", "
							-- typelist = typelist .. ", "
						end
					end

					query2 = query2 .. keylist .. ") VALUES ("
					for i = 1, f do
						query2 = query2 .. " NULL"
						if i < f then
 							query2 = query2 .. ", "
						end
					end
					query2 = query2 .. ")"
					-- print ("q1 : " .. query2)
					-- print ("q2 : " .. query2)

					query = query .. ")"
					-- print ("executing query : " .. query)
					sql:exe( query )
					sql:exe( query2 )

					window:destroy()
					listTables()
				else
					-- print "null table name"
				end
			elseif action == "edit" then
				-- print "accept edit table"

				keys, types = window:getDynamicData()
				f = window:getDynamicElementCount()
				-- print ( "current_table: "  .. current_table )

				for i = 1, f do
					query = "ALTER TABLE " .. current_table .. " ADD COLUMN " .. keys[i] .. " " .. types[i]
					-- print ( "key: "  .. keys[i] )
					-- print ( "type: "  .. types[i] )
					-- print ( "query: "  .. query )
					sql:exe( query )
				end
				window:destroy()
				listRows()

				-- create temp_table (clone rename existing table)
				-- move data into temp table
				-- delete existing table
				-- create new table with old table's name
				-- move data from temp_table to new table
				-- delete temp table

			elseif action == "delete" then
				query = "DROP TABLE " .. current_table
				-- print ("executing query : " .. query)
				sql:exe( query )
				window:destroy()
				listTables()
			elseif action == "run" then
				-- print "Run Query!"

			end
		elseif substate == "row" then
			if action == "add" then
				-- print "accept add row"
				query = "INSERT INTO " .. current_table .. " ("
				q = sql:exe( "SELECT * FROM " .. current_table .. " WHERE 0 = 0;" )
				keylist = ""
				vallist = ""

				for i = 0, q:getHeadCount()-1 do
					keylist = keylist .. q:getHead( i )

					v = window:getValue( q:getHead( i ) )
					if tonumber(v) == nil then
						vallist = vallist ..  "'" .. window:getValue( q:getHead( i ) ) .. "'"
					else
						vallist = vallist ..  window:getValue( q:getHead( i ) )
					end

					if i < q:getHeadCount()-1 then
						query = query .. ", "
						keylist = keylist .. ", "
						vallist = vallist .. ", "
					end
				end
				sql:removeResult( q )				
				query = "INSERT INTO " .. current_table .. " (" .. keylist .. ") VALUES ( " .. vallist .. " )"
				-- print ("query:" .. query)
				sql:exe( query )
				window:destroy()
				listRows()
			elseif action == "edit" then
				-- print "accept edit row"
				query = "UPDATE " .. current_table .. " SET "
				q = sql:exe( "SELECT * FROM " .. current_table .. " WHERE 0 = 0;" )
				for i = 0, q:getHeadCount()-1 do
					v = window:getValue( q:getHead( i ) )
					if tonumber(v) == nil then
						query = query .. q:getHead( i ) .. "='" ..  v .. "'"
					else
						query = query .. q:getHead( i ) .. "=" ..  v
					end

					if i < q:getHeadCount()-1 then
						query = query .. ", "
					end
				end
				sql:removeResult( q )
	
				p = table_rows:getCellText ( table_rows:getSelected(), 0  )
				query = query .. " WHERE ROWID = " .. p
				-- print ( "query :" .. query )

				sql:exe( query )
				window:destroy()
				listRows()
			elseif action == "delete" then
				-- print "accept delete row"
				p = table_rows:getCellText ( table_rows:getSelected(), 0  )
				query = "DELETE FROM " .. current_table .. " WHERE ROWID = " .. p
				-- print ("query: " .. query )
				sql:exe( query )
				window:destroy()
				listRows()
			elseif action == "run" then
				-- print "Run Query!"
				q = window:getEditText()
				-- print "a"
				if q ~= nil then
					-- print ( "query : " .. q )
					sql:exe( q )
					window:destroy()
					showRunResults()
				else
					-- print "no valid query"
				end
			end
		end
	end
end

-- Move this function into xlib
function string:split(delimiter)
	local result = { }
	local from  = 1
	local delim_from, delim_to = string.find( self, delimiter, from  )
	while delim_from do
		table.insert( result, string.sub( self, from , delim_from-1 ) )
		from  = delim_to + 1
		delim_from, delim_to = string.find( self, delimiter, from  )
	end
	table.insert( result, string.sub( self, from  ) )
	return result
end

-- end of file