-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- edit_classes.lua

edit_classes = { ID = 0 }

-- print "[edit_classes]"

-- creation
function edit_classes:new (o)
	-- print "[edit_classes] new edit_classes"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 60
	btn_h = 30

	--
	-- list window
	--
	x = 10
	y = 60
	window_edit_classes_list = sim:addWindow( 1000, xcore.x2drect(x, y, x+128, y+256+60), "Class List")
	window_edit_classes_list:setTitleBarVisible( false )		
	image_background_edit_list = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_edit_list:setParent( window_edit_classes_list )
	
	-- list
	width = 118	
	x = 5
	y = 10
	height = 236
	listbox_edit_classes = sim:addListbox( 1010, true, xcore.x2drect( x,y,x+width,y+height ) )
	listbox_edit_classes:setParent( window_edit_classes_list )
	listbox_edit_classes:addItem("test")

	x = 0
	y = 256

	button_edit_classes_edit = sim:addButton( 2002, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_edit_classes_edit:setParent( window_edit_classes_list )		
	button_edit_classes_edit:setImage( button_small_texture )
	button_edit_classes_edit:setPressedImage( button_small_pressed_texture )	

	x = x+ btn_w + 6
	button_edit_classes_delete = sim:addButton( 2003, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_edit_classes_delete:setParent( window_edit_classes_list )		
	button_edit_classes_delete:setImage( button_small_texture )
	button_edit_classes_delete:setPressedImage( button_small_pressed_texture )	

	x = 0
	y = y + 30
	btn_w = 128
	-- add some buttons
	button_edit_classes_add = sim:addButton( 2001, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_edit_classes_add:setParent( window_edit_classes_list )	
	button_edit_classes_add:setImage( button_texture )
	button_edit_classes_add:setPressedImage( button_pressed_texture )	

	
	sim:bindGUI ( "button_edit_classes_add_pressed", 2001, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_classes_edit_pressed", 2002, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_classes_delete_pressed", 2003, xcore.XGUI_BUTTON_CLICKED )

	--
	-- data window
	--
	x = 260
	y = 60
	window_edit_classes_data = sim:addWindow( 1000, xcore.x2drect(x, y, x+380, y+450), "Class Data")	
	
	y = 30
	x = 20	
	-- add text input for name
	label_edit_classes_name = sim:addText( 0, "Name", x, y, x+100, y+20 )
	label_edit_classes_name:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_name = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_classes_name:setParent( window_edit_classes_data )	

	y = y + 30
	x = 20		
	-- add text input for Graphic
	label_edit_classes_wpn = sim:addText( 0, "Weapon Skill", x, y, x+100, y+20 )
	label_edit_classes_wpn:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_wpn = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_classes_wpn:setParent( window_edit_classes_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for class
	label_edit_classes_arm = sim:addText( 0, "Arm Skill", x, y, x+100, y+20 )
	label_edit_classes_arm:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_arm = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_classes_arm:setParent( window_edit_classes_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for class
	label_edit_classes_type = sim:addText( 0, "Type", x, y, x+100, y+20 )
	label_edit_classes_type:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_type = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_classes_type:setParent( window_edit_classes_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for tier
	label_edit_classes_tier = sim:addText( 0, "Tier", x, y, x+100, y+20 )
	label_edit_classes_tier:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_tier = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_classes_tier:setParent( window_edit_classes_data )	
	
	y = y + 30
	x = 20		
	-- add numeric inputs for desc
	label_edit_classes_desc = sim:addText( 0, "Desc", x, y, x+100, y+20 )
	label_edit_classes_desc:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_desc = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_classes_desc:setParent( window_edit_classes_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for class
	label_edit_classes_graphic = sim:addText( 0, "Graphic", x, y, x+100, y+20 )
	label_edit_classes_graphic:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_graphic = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_classes_graphic:setParent( window_edit_classes_data )	

	y = y + 30
	x = 20		
	-- add seperator
	label_edit_classes_sep = sim:addText( 0, "Stats ", x, y, x+150, y+20 )
	label_edit_classes_sep:setParent( window_edit_classes_data )

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_classes_atk = sim:addText( 0, "Atk", x, y, x+50, y+20 )
	label_edit_classes_atk:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_atk = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_classes_atk:setParent( window_edit_classes_data )	
	x = x + 50
	label_edit_classes_def = sim:addText( 0, "Def", x, y, x+50, y+20 )
	label_edit_classes_def:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_def = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_classes_def:setParent( window_edit_classes_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_classes_mov = sim:addText( 0, "Mov", x, y, x+50, y+20 )
	label_edit_classes_mov:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_mov = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_classes_mov:setParent( window_edit_classes_data )	
	x = x + 50
	label_edit_classes_rng = sim:addText( 0, "Rng", x, y, x+50, y+20 )
	label_edit_classes_rng:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_rng = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_classes_rng:setParent( window_edit_classes_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_classes_hp = sim:addText( 0, "HP", x, y, x+50, y+20 )
	label_edit_classes_hp:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_hp = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_classes_hp:setParent( window_edit_classes_data )	
	x = x + 50
	label_edit_classes_sp = sim:addText( 0, "SP", x, y, x+50, y+20 )
	label_edit_classes_sp:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_sp = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_classes_sp:setParent( window_edit_classes_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_classes_dam = sim:addText( 0, "Dam", x, y, x+50, y+20 )
	label_edit_classes_dam:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_dam = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_classes_dam:setParent( window_edit_classes_data )	
	x = x + 50
	label_edit_classes_drn = sim:addText( 0, "Drn", x, y, x+50, y+20 )
	label_edit_classes_drn:setParent( window_edit_classes_data )
	x = x+110
	textfield_edit_classes_drn = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_classes_drn:setParent( window_edit_classes_data )		

	y = y + 50
	btn_w = 160
	x = 120
	button_edit_classes_save = sim:addButton( 2011, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Save" )
	button_edit_classes_save:setParent( window_edit_classes_data )		
	button_edit_classes_save:setImage( button_texture )
	button_edit_classes_save:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_edit_classes_save_pressed", 2011, xcore.XGUI_BUTTON_CLICKED )

	stat_id = -1
	self.mode = 1
	self.current_class_id = -1

	self:hide()
	return o
end

function edit_classes:hide()
	-- print "[edit_classes] hide"
	window_edit_classes_list:setVisible( false )
	window_edit_classes_data:setVisible( false )
end

function edit_classes:show()
	-- print "[edit_classes] show"
	self:updateList()

	window_edit_classes_list:setVisible( true )
	-- print "[edit_classes] /show"
end

function edit_classes:destroy()
	-- print "[edit_classes] destroy"
	window_edit_classes_list:destroy()
end

function edit_classes:input()
	if sim:isGUI( "button_edit_classes_add_pressed" ) then
		print("button_edit_classes_add_pressed")
		window_edit_classes_data:setVisible( true )
		self:showAdd()
	end
	if sim:isGUI( "button_edit_classes_edit_pressed" ) then
		print("button_edit_classes_edit_pressed")
		window_edit_classes_data:setVisible( true )
		self:showEdit()
	end
	if sim:isGUI( "button_edit_classes_delete_pressed" ) then
		print("button_edit_classes_delete_pressed")
		self:delete()
	end	
	if sim:isGUI( "button_edit_classes_save_pressed" ) then
		print("button_edit_classes_save_pressed")
		self:save()
	end	
end

function edit_classes:save()
	print("[edit_classes] save")
	-- item_name, item_type, item_class, item_effect, item_graphic, item_stat, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp

	if self.mode == 1 then
		print("[edit_classes] insert row")
		query = " INSERT INTO table_stats "
		query = query .. " ( stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp )"
		query = query .. "VALUES ( "
		query = query .. textfield_edit_classes_atk:getText() .. ", "
		query = query .. textfield_edit_classes_def:getText() .. ", "
		query = query .. textfield_edit_classes_mov:getText() .. ", "
		query = query .. textfield_edit_classes_rng:getText() .. ", "
		query = query .. textfield_edit_classes_dam:getText() .. ", "
		query = query .. textfield_edit_classes_drn:getText() .. ", "
		query = query .. textfield_edit_classes_sp:getText() .. ", "
		query = query .. textfield_edit_classes_hp:getText() .. " "
		query = query .. " ); SELECT last_insert_rowid()"
		print ( query )
		q = sql:exe( query )
		print("last_insert_rowid: " .. q:getData( 0 ) )

		stat_id = q:getData( 0 )
		sql:removeResult( q )

		query = " INSERT INTO table_classes "
		query = query .. " ( class_name, class_wpn, class_arm, class_type, class_graphic, class_stat, class_tier, class_desc )"
		query = query .. "VALUES ( "
		query = query .. "'".. textfield_edit_classes_name:getText() .. "', "
		query = query .. "'".. textfield_edit_classes_wpn:getText() .. "', "
		query = query .. "'".. textfield_edit_classes_arm:getText() .. "', "
		query = query .. "'".. textfield_edit_classes_type:getText() .. "', "
		query = query .. "'".. textfield_edit_classes_graphic:getText() .. "', "
		query = query .. stat_id .. ",  "
		query = query .. " ".. textfield_edit_classes_tier:getText() .. ", "
		query = query .. "'".. textfield_edit_classes_desc:getText() .. "' "	
		
		query = query .. " )"
		print( query )
		sql:exe( query )
	else
		print("[edit_classes] update row")
		query = "UPDATE table_stats SET "
		query = query .. " stat_attack = '" .. textfield_edit_classes_atk:getText() .. "', "
		query = query .. " stat_defense = '" .. textfield_edit_classes_def:getText() .. "', "
		query = query .. " stat_speed = " .. textfield_edit_classes_mov:getText() .. ", "
		query = query .. " stat_range = " .. textfield_edit_classes_rng:getText() .. ", "
		query = query .. " stat_damage = " .. textfield_edit_classes_dam:getText() .. ", "
		query = query .. " stat_drain = " .. textfield_edit_classes_drn:getText() .. ", "
		query = query .. " stat_sp = " .. textfield_edit_classes_sp:getText() .. ", "
		query = query .. " stat_hp = " .. textfield_edit_classes_hp:getText() .. " "
		query = query .. " WHERE stat_id = " .. stat_id
		
		print ( query )
		q = sql:exe( query )
		
		query = "UPDATE table_classes SET "
		query = query .. " class_name = '" .. textfield_edit_classes_name:getText() .. "', "
		query = query .. " class_wpn = '" .. textfield_edit_classes_wpn:getText() .. "', "
		query = query .. " class_arm = '" .. textfield_edit_classes_arm:getText() .. "', "
		query = query .. " class_type = '" .. textfield_edit_classes_type:getText() .. "', "
		query = query .. " class_graphic = '" .. textfield_edit_classes_graphic:getText() .. "', "
		query = query .. " class_tier = ".. textfield_edit_classes_tier:getText() .. ", "
		query = query .. " class_desc = '".. textfield_edit_classes_desc:getText() .. "', "		
		query = query .. " class_stat = " .. stat_id

		query = query .. " WHERE class_id = " .. self.current_class_id
		print( query )
		sql:exe( query )
	end
	self:updateList()
end

function edit_classes:delete()
	if listbox_edit_classes:getSelected() == -1 then return nil end
	n = listbox_edit_classes:getItem( listbox_edit_classes:getSelected() )
	print("[edit_classes] delete class : " .. n)
	
	query = "DELETE FROM table_classes WHERE class_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if stat_id > 0 then 
		print("[edit_classes] delete statline : " .. stat_id)
		query = "DELETE FROM table_stats WHERE stat_id = '" ..  stat_id .. "'"
		local q = sql:exe( query )
	end
	
	self:updateList()
end

function edit_classes:showAdd()
	self.mode = 1
	print "[edit_classes] showAdd"
	-- show confirmation
	textfield_edit_classes_name:setText("")
	textfield_edit_classes_wpn:setText( "0" )
	textfield_edit_classes_arm:setText( "0" )

	textfield_edit_classes_atk:setText( "0" )
	textfield_edit_classes_def:setText( "0" )
	textfield_edit_classes_mov:setText( "0" )
	textfield_edit_classes_rng:setText( "0" )
	textfield_edit_classes_dam:setText( "0" )
	textfield_edit_classes_drn:setText( "0" )
	textfield_edit_classes_sp:setText( "0" )
	textfield_edit_classes_hp:setText( "0" )
	textfield_edit_classes_tier:setText( "0" )
	textfield_edit_classes_desc:setText( "" )
	
	textfield_edit_classes_graphic:setText( "" )	
	stat_id = -1
end

function edit_classes:showEdit()
	self.mode = 2
	-- print "[edit_classes] showEdit"
	-- show confirmation

	n = listbox_edit_classes:getItem( listbox_edit_classes:getSelected() )
	-- print("[edit_classes] edit item : " .. n)
	query = "SELECT class_name, class_type, class_wpn, class_arm, class_graphic, class_stat, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp, class_id, class_tier, class_desc FROM table_classes LEFT JOIN table_stats on stat_id = class_stat WHERE class_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_classes] name : " .. q:getData( 0 ) )
			textfield_edit_classes_name:setText( q:getData( 0 ) )
		end
		if q:getData( 1 ) ~= nil then
			-- print ( q:getData( 1 ) )
			textfield_edit_classes_type:setText( q:getData( 1 ) )
		end
		if q:getData( 2 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_classes_wpn:setText( q:getData( 2 ) )
		end
		if q:getData( 3 ) ~= nil then
			textfield_edit_classes_arm:setText( q:getData( 3 ) )
		end
		if q:getData( 4 ) ~= nil then -- item_effect
			textfield_edit_classes_graphic:setText( q:getData( 4 ) )
		end		
		if q:getData( 5 ) ~= nil then
			-- print ("[edit_classes] statline ID : " ..  q:getData( 5 ) )
			stat_id = tonumber( q:getData( 5 ) )
		else
			stat_id = -1
		end
		
		if q:getData( 6 ) ~= nil then
			textfield_edit_classes_atk:setText( q:getData( 6 ) )
		end
		if q:getData( 7 ) ~= nil then
			textfield_edit_classes_def:setText( q:getData( 7 ) )
		end
		if q:getData( 8 ) ~= nil then
			textfield_edit_classes_mov:setText( q:getData( 8 ) )
		end
		if q:getData( 9 ) ~= nil then
			textfield_edit_classes_rng:setText( q:getData( 9 ) )
		end
		if q:getData( 10 ) ~= nil then
			textfield_edit_classes_dam:setText( q:getData( 10 ) )
		end
		if q:getData( 11 ) ~= nil then
			textfield_edit_classes_drn:setText( q:getData( 11 ) )
		end
		if q:getData( 12 ) ~= nil then
			textfield_edit_classes_sp:setText( q:getData( 12 ) )
		end
		if q:getData( 13 ) ~= nil then
			textfield_edit_classes_hp:setText( q:getData( 13 ) )
		end
		
		self.current_class_id = tonumber( q:getData( 14 ) )
		
		window_edit_classes_data:setText("Class Data ( ID " .. self.current_class_id .." )")
		
		if q:getData( 15 ) ~= nil then
			textfield_edit_classes_tier:setText( q:getData( 15 ) )
		end
		if q:getData( 16 ) ~= nil then
			textfield_edit_classes_desc:setText( q:getData( 16 ) )
		end		
	--[[
		textfield_edit_classes_atk
		textfield_edit_classes_def
		textfield_edit_classes_mov
		textfield_edit_classes_rng
		textfield_edit_classes_hp
		textfield_edit_classes_sp
		textfield_edit_classes_dam
		textfield_edit_classes_drn
	]]--
	end
end


function edit_classes:showDelete()
	print "[edit_classes] showDelete"
	-- show confirmation
end

function edit_classes:updateList()
	print "[edit_classes] updateList"
	listbox_edit_classes:clear()
	statement = "SELECT class_name FROM table_classes WHERE 0 = 0 ORDER BY class_type ASC, class_name ASC"
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				listbox_edit_classes:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
	window_edit_classes_data:setVisible( false )
end

-- end of file