-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- edit_dialog.lua

edit_dialog = { ID = 0 }

-- print "[edit_dialog]"

-- creation
function edit_dialog:new (o)
	-- print "[edit_dialog] new edit_dialog"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 60
	btn_h = 30
	--
	-- list window
	--
	x = 10
	y = 60
	window_edit_dialog_list = sim:addWindow( 1000, xcore.x2drect(x, y, x+128, y+256+60), "Dialog List")
	window_edit_dialog_list:setTitleBarVisible( false )		
	image_background_edit_list = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_edit_list:setParent( window_edit_dialog_list )
	
	-- list
	width = 118	
	x = 5
	y = 10
	height = 236
	listbox_edit_dialog = sim:addListbox( 1010, true, xcore.x2drect( x,y,x+width,y+height ) )
	listbox_edit_dialog:setParent( window_edit_dialog_list )
	listbox_edit_dialog:addItem("test")
	x = 0
	y = 256

	button_edit_dialog_edit = sim:addButton( 2602, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_edit_dialog_edit:setParent( window_edit_dialog_list )		
	button_edit_dialog_edit:setImage( button_small_texture )
	button_edit_dialog_edit:setPressedImage( button_small_pressed_texture )	

	x = x+ btn_w + 6
	button_edit_dialog_delete = sim:addButton( 2603, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_edit_dialog_delete:setParent( window_edit_dialog_list )		
	button_edit_dialog_delete:setImage( button_small_texture )
	button_edit_dialog_delete:setPressedImage( button_small_pressed_texture )	

	x = 0
	y = y + 30
	btn_w = 128
	-- add some buttons
	button_edit_dialog_add = sim:addButton( 2601, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_edit_dialog_add:setParent( window_edit_dialog_list )	
	button_edit_dialog_add:setImage( button_texture )
	button_edit_dialog_add:setPressedImage( button_pressed_texture )	
	
	sim:bindGUI ( "button_edit_dialog_add_pressed", 2601, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_dialog_edit_pressed", 2602, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_dialog_delete_pressed", 2603, xcore.XGUI_BUTTON_CLICKED )

	--
	-- data window
	--
	x = 260
	y = 60
	window_edit_dialog_data = sim:addWindow( 1000, xcore.x2drect(x, y, x+380, y+400), "Dialog Data")	
	
	y = 30
	x = 20
	-- add input for name
	label_edit_dialog_stage = sim:addText( 0, "Stage", x, y, x+100, y+20 )
	label_edit_dialog_stage:setParent( window_edit_dialog_data )
	x = x+110
	textfield_edit_dialog_stage = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_dialog_stage:setParent( window_edit_dialog_data )	

	y = y + 30
	x = 20		
	-- add input for name
	label_edit_dialog_depth = sim:addText( 0, "Depth", x, y, x+100, y+20 )
	label_edit_dialog_depth:setParent( window_edit_dialog_data )
	x = x+110
	textfield_edit_dialog_depth = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_dialog_depth:setParent( window_edit_dialog_data )	


	y = y + 30
	x = 20		
	-- add inputs for max
	label_edit_dialog_order = sim:addText( 0, "Order", x, y, x+100, y+20 )
	label_edit_dialog_order:setParent( window_edit_dialog_data )
	x = x+110
	textfield_edit_dialog_order = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_dialog_order:setParent( window_edit_dialog_data )		
	
	y = y + 30
	x = 20		
	label_edit_dialog_target = sim:addText( 0, "Target", x, y, x+100, y+20 )
	label_edit_dialog_target:setParent( window_edit_dialog_data )
	x = x+110
	textfield_edit_dialog_target = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_dialog_target:setParent( window_edit_dialog_data )	

	y = y + 30
	x = 20		
	-- add inputs for dialog type
	label_edit_dialog_type = sim:addText( 0, "Type", x, y, x+100, y+20 )
	label_edit_dialog_type:setParent( window_edit_dialog_data )
	x = x+110
	combobox_edit_dialog_type = sim:addCombobox( 100, xcore.x2drect(x, y, x+150, y+20 ) )
	combobox_edit_dialog_type:setParent( window_edit_dialog_data )
	combobox_edit_dialog_type:addItem("DIALOG_STATEMENT")
	combobox_edit_dialog_type:addItem("DIALOG_QUESTION")
	combobox_edit_dialog_type:addItem("DIALOG_REPLY")
	

	y = y + 30
	x = 20		
	-- add inputs for depth
	label_edit_dialog_text = sim:addText( 0, "Text", x, y, x+100, y+20 )
	label_edit_dialog_text:setParent( window_edit_dialog_data )
	x = x+110
	textfield_edit_dialog_text = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_dialog_text:setParent( window_edit_dialog_data )	

	y = y + 30
	x = 20		
	-- add inputs for dialog_char
	label_edit_dialog_char = sim:addText( 0, "PC index", x, y, x+100, y+20 )
	label_edit_dialog_char:setParent( window_edit_dialog_data )
	x = x+110
	textfield_edit_dialog_char = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_dialog_char:setParent( window_edit_dialog_data )	

	y = y + 30
	x = 20		
	-- add inputs for min
	label_edit_dialog_name = sim:addText( 0, "NPC Name", x, y, x+100, y+20 )
	label_edit_dialog_name:setParent( window_edit_dialog_data )
	x = x+110
	textfield_edit_dialog_name = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_dialog_name:setParent( window_edit_dialog_data )	

	y = y + 30
	x = 20		
	-- add inputs for max
	label_edit_dialog_icon = sim:addText( 0, "NPC Icon", x, y, x+100, y+20 )
	label_edit_dialog_icon:setParent( window_edit_dialog_data )
	x = x+110
	textfield_edit_dialog_icon = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_dialog_icon:setParent( window_edit_dialog_data )	

	y = y + 50
	btn_w = 160
	x = 120
	button_edit_dialog_save = sim:addButton( 2611, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Save" )
	button_edit_dialog_save:setParent( window_edit_dialog_data )		
	button_edit_dialog_save:setImage( button_texture )
	button_edit_dialog_save:setPressedImage( button_pressed_texture )
	
	
	sim:bindGUI ( "button_edit_dialog_save_pressed", 2611, xcore.XGUI_BUTTON_CLICKED )

	stat_id = -1
	self.mode = 1
	self.current_dialog_id = -1

	self:hide()
	return o
end

function edit_dialog:hide()
	-- print "[edit_dialog] hide"
	window_edit_dialog_list:setVisible( false )
	window_edit_dialog_data:setVisible( false )
	
	-- prolly shouldnt be here
	game_history:hide( true )
	game_alert:hide(  true  )
	game_manager:hide(  true )
end


function edit_dialog:show()
	-- print "[edit_dialog] show"
	self:updateList()

	window_edit_dialog_list:setVisible( true )
	-- print "[edit_dialog] /show"
end

function edit_dialog:destroy()
	-- print "[edit_dialog] destroy"
	window_edit_dialog_list:destroy()
end

function edit_dialog:input()
	if sim:isGUI( "button_edit_dialog_add_pressed" ) then
		window_edit_dialog_data:setVisible( true )
		self:showAdd()
	end
	if sim:isGUI( "button_edit_dialog_edit_pressed" ) then
		window_edit_dialog_data:setVisible( true )
		self:showEdit()
	end
	if sim:isGUI( "button_edit_dialog_delete_pressed" ) then
		self:delete()
	end	
	if sim:isGUI( "button_edit_dialog_save_pressed" ) then
		self:save()
	end	
end

function edit_dialog:save()

	
	--[[
	dialog_stage        -- what stage this dialog plays at
	dialog_depth        -- what substage
	dialog_target       -- next option in chain?
	dialog_type         -- dialog / option
	dialog_text         -- the dialog text
	dialog_char         -- optional, what user mob says this line (marching order)
	dialog_name         -- optional, what NPC says this line.
	dialog_icon         -- optional, icon for NPC dialog line
	dialog_order        -- sort order.
	--]]

	

	print("[edit_dialog] save")
	if self.mode == 1 then
		query = " INSERT INTO table_dialog "
		query = query .. " ( dialog_stage, dialog_depth, dialog_target, dialog_type, dialog_text, dialog_char_index, dialog_name, dialog_icon, dialog_order  )"
		query = query .. "VALUES ( "
		query = query .. "'".. textfield_edit_dialog_stage:getText() .. "', "
		query = query .. "'".. textfield_edit_dialog_depth:getText() .. "', "
		query = query .. "'".. textfield_edit_dialog_target:getText() .. "', "
		query = query .. "'".. combobox_edit_dialog_type:getSelected() .. "', "
		query = query .. "'".. textfield_edit_dialog_text:getText() .. "', "		
		query = query .. "'".. textfield_edit_dialog_char:getText() .. "', "
		query = query .. "'".. textfield_edit_dialog_name:getText() .. "', "
		query = query .. "'".. textfield_edit_dialog_icon:getText() .. "', "
		query = query .. " ".. textfield_edit_dialog_order:getText() .. " "
		query = query .. " )"
		-- print( query )
		sql:exe( query )
	else
		query = "UPDATE table_dialog SET "
		query = query .. " dialog_stage = '" .. textfield_edit_dialog_stage:getText() .. "', "
		query = query .. " dialog_depth = ".. textfield_edit_dialog_depth:getText() .. ", "
		query = query .. " dialog_target = '" .. textfield_edit_dialog_target:getText() .. "', "
		query = query .. " dialog_type = '" .. combobox_edit_dialog_type:getSelected() .. "', "

		query = query .. " dialog_text = '" .. textfield_edit_dialog_text:getText() .. "', "
		query = query .. " dialog_char_index = '" .. textfield_edit_dialog_char:getText() .. "', "
		query = query .. " dialog_name = '" .. textfield_edit_dialog_name:getText() .. "', "
		query = query .. " dialog_name = '" .. textfield_edit_dialog_name:getText() .. "', "
		query = query .. " dialog_icon = '" .. textfield_edit_dialog_icon:getText() .. "',  "
		query = query .. " dialog_order = '" .. textfield_edit_dialog_order:getText() .. "' "		
		query = query .. " WHERE dialog_id = " .. self.current_dialog_id
		-- print( query )
		sql:exe( query )
	end
	self:updateList()
end

function edit_dialog:delete()
	if listbox_edit_dialog:getSelected() == -1 then return nil end
	n = listbox_edit_dialog:getItem( listbox_edit_dialog:getSelected() )
	-- print("[edit_dialog] delete tile : " .. n)
	
	query = "DELETE FROM table_dialog WHERE dialog_id = '" ..  n .. "'"
	local q = sql:exe( query )
	
	self:updateList()
end

function edit_dialog:showAdd()
	self.mode = 1
	print "[edit_dialog] showAdd"
	-- show confirmation
	textfield_edit_dialog_stage:setText("")
	combobox_edit_dialog_type:setSelected( 0 )
	textfield_edit_dialog_target:setText("")
	textfield_edit_dialog_depth:setText("")
	textfield_edit_dialog_char:setText("")
	textfield_edit_dialog_name:setText("")	
	textfield_edit_dialog_icon:setText("")
	textfield_edit_dialog_text:setText("")
	textfield_edit_dialog_order:setText("")
end

function edit_dialog:showEdit()
	self.mode = 2
	-- print "[edit_dialog] showEdit"

	-- show confirmation
	n = listbox_edit_dialog:getItem( listbox_edit_dialog:getSelected() )
	-- print("[edit_dialog] edit item : " .. n)
	query = "SELECT dialog_stage, dialog_type, dialog_target, dialog_depth, dialog_name, dialog_icon, dialog_id, dialog_order, dialog_text, dialog_char_index FROM table_dialog WHERE dialog_id = '" ..  n .. "'"
	print( query )
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_dialog] name : " .. q:getData( 0 ) )
			textfield_edit_dialog_stage:setText( q:getData( 0 ) )
		end
		if q:getData( 1 ) ~= nil then
			-- print ( q:getData( 1 ) )
			if tonumber( q:getData( 1 ) ) ~= nil then
				combobox_edit_dialog_type:setSelected( tonumber( q:getData( 1 ) )  )
			else
				combobox_edit_dialog_type:setSelected( 0 )
			end
		end
		if q:getData( 2 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_dialog_target:setText( q:getData( 2 ) )	
		end
		if q:getData( 3 ) ~= nil then
			textfield_edit_dialog_depth:setText( tonumber( q:getData( 3 ) ) )
		end
		if q:getData( 4 ) ~= nil then
			textfield_edit_dialog_name:setText( q:getData( 4 ) )
		end
		if q:getData( 5 ) ~= nil then
			textfield_edit_dialog_icon:setText( q:getData( 5 ) )
		end

		self.current_dialog_id = tonumber( q:getData( 6 ) )
		
		if q:getData( 7 ) ~= nil then
			textfield_edit_dialog_order:setText( q:getData( 7 ) )
		end		
		if q:getData( 8 ) ~= nil then
			textfield_edit_dialog_text:setText( q:getData( 8 ) )
		end
		if q:getData( 9 ) ~= nil then
			textfield_edit_dialog_char:setText( q:getData( 9 ) )
		end
	end
end

function edit_dialog:showDelete()
	-- print "[edit_dialog] showDelete"
	-- show confirmation
end

function edit_dialog:updateList()
	print "[edit_dialog] updateList"
	listbox_edit_dialog:clear()
	statement = "SELECT dialog_id FROM table_dialog WHERE 0 = 0 ORDER BY dialog_stage ASC, dialog_depth ASC "
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				listbox_edit_dialog:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
	window_edit_dialog_data:setVisible( false )
end

-- end of file