-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- edit_items.lua

edit_items = { ID = 0 }

-- print "[edit_items]"

-- creation
function edit_items:new (o)
	-- print "[edit_items] new edit_items"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 60
	btn_h = 30

	--
	-- list window
	--
	x = 10
	y = 60
	window_edit_items_list = sim:addWindow( 1000, xcore.x2drect(x, y, x+128, y+256+60), "Encounter List")
	window_edit_items_list:setTitleBarVisible( false )		
	image_background_edit_list = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_edit_list:setParent( window_edit_items_list )

	-- list
	width = 124
	x = 5
	y = 10
	height = 236
	listbox_edit_items = sim:addListbox( 1010, true, xcore.x2drect( x,y,x+width,y+height ) )
	listbox_edit_items:setParent( window_edit_items_list )
	listbox_edit_items:addItem("test")
	

	x = 0
	y = 256
	button_edit_items_edit = sim:addButton( 1002, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_edit_items_edit:setParent( window_edit_items_list )		
	button_edit_items_edit:setImage( button_small_texture )
	button_edit_items_edit:setPressedImage( button_small_pressed_texture )
	
	x = x+ btn_w + 6
	button_edit_items_delete = sim:addButton( 1003, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_edit_items_delete:setParent( window_edit_items_list )		
	button_edit_items_delete:setImage( button_small_texture )
	button_edit_items_delete:setPressedImage( button_small_pressed_texture )

	x = 0
	y = y + 30
	btn_w = 128
	button_edit_items_add = sim:addButton( 1001, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_edit_items_add:setParent( window_edit_items_list )	
	button_edit_items_add:setImage( button_texture )
	button_edit_items_add:setPressedImage( button_pressed_texture )	
	
	sim:bindGUI ( "button_edit_items_add_pressed", 1001, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_items_edit_pressed", 1002, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_items_delete_pressed", 1003, xcore.XGUI_BUTTON_CLICKED )

	--
	-- data window
	--
	x = 260
	y = 60
	window_edit_items_data = sim:addWindow( 1000, xcore.x2drect(x, y, x+380, y+400), "Item Data")	
	
	y = 30
	x = 20	
	-- add text input for name
	label_edit_items_name = sim:addText( 0, "Name", x, y, x+100, y+20 )
	label_edit_items_name:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_name = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_items_name:setParent( window_edit_items_data )	

	y = y + 30
	x = 20		
	-- add text input for Graphic
	label_edit_items_graphic = sim:addText( 0, "Graphic", x, y, x+100, y+20 )
	label_edit_items_graphic:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_item_graphic = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_item_graphic:setParent( window_edit_items_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for type
	label_edit_items_type = sim:addText( 0, "Type", x, y, x+50, y+20 )
	label_edit_items_type:setParent( window_edit_items_data )
	x = x+110
	combobox_edit_items_type = sim:addCombobox( 100, xcore.x2drect(x, y, x+150, y+20 ) )
	combobox_edit_items_type:setParent( window_edit_items_data )
	combobox_edit_items_type:addItem("Weapon")
	combobox_edit_items_type:addItem("Armor")
	combobox_edit_items_type:addItem("Accessory")	
	combobox_edit_items_type:addItem("Consumable")
	combobox_edit_items_type:addItem("Relic")

	y = y + 30
	x = 20		
	-- add numeric inputs for class
	label_edit_items_class = sim:addText( 0, "Class", x, y, x+50, y+20 )
	label_edit_items_class:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_class = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_items_class:setParent( window_edit_items_data )

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_items_class = sim:addText( 0, "Class", x, y, x+50, y+20 )
	label_edit_items_class:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_class = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_class:setParent( window_edit_items_data )	
	x = x + 50
	label_edit_items_level = sim:addText( 0, "Level", x, y, x+50, y+20 )
	label_edit_items_level:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_level = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_level:setParent( window_edit_items_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_items_rarity = sim:addText( 0, "Rarity", x, y, x+50, y+20 )
	label_edit_items_rarity:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_rarity = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_rarity:setParent( window_edit_items_data )	
	x = x + 50
	label_edit_items_value = sim:addText( 0, "Value", x, y, x+50, y+20 )
	label_edit_items_value:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_value = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_value:setParent( window_edit_items_data )		

	y = y + 30
	x = 20		
	-- add seperator
	label_edit_items_sep = sim:addText( 0, "Stats ", x, y, x+150, y+20 )
	label_edit_items_sep:setParent( window_edit_items_data )

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_items_atk = sim:addText( 0, "Atk", x, y, x+50, y+20 )
	label_edit_items_atk:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_atk = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_atk:setParent( window_edit_items_data )	
	x = x + 50
	label_edit_items_def = sim:addText( 0, "Def", x, y, x+50, y+20 )
	label_edit_items_def:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_def = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_def:setParent( window_edit_items_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_items_mov = sim:addText( 0, "Mov", x, y, x+50, y+20 )
	label_edit_items_mov:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_mov = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_mov:setParent( window_edit_items_data )	
	x = x + 50
	label_edit_items_rng = sim:addText( 0, "Rng", x, y, x+50, y+20 )
	label_edit_items_rng:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_rng = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_rng:setParent( window_edit_items_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_items_hp = sim:addText( 0, "HP", x, y, x+50, y+20 )
	label_edit_items_hp:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_hp = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_hp:setParent( window_edit_items_data )	
	x = x + 50
	label_edit_items_sp = sim:addText( 0, "SP", x, y, x+50, y+20 )
	label_edit_items_sp:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_sp = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_sp:setParent( window_edit_items_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_items_dam = sim:addText( 0, "Dam", x, y, x+50, y+20 )
	label_edit_items_dam:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_dam = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_dam:setParent( window_edit_items_data )	
	x = x + 50
	label_edit_items_drn = sim:addText( 0, "Drn", x, y, x+50, y+20 )
	label_edit_items_drn:setParent( window_edit_items_data )
	x = x+110
	textfield_edit_items_drn = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_items_drn:setParent( window_edit_items_data )		

	y = y + 50
	btn_w = 160
	x = 120
	button_edit_items_save = sim:addButton( 1011, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Save" )
	button_edit_items_save:setParent( window_edit_items_data )		
	button_edit_items_save:setImage( button_texture )
	button_edit_items_save:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_edit_items_save_pressed", 1011, xcore.XGUI_BUTTON_CLICKED )

	stat_id = -1
	self.mode = 1
	self.current_item_id = -1

	self:hide()
	return o
end

function edit_items:hide()
	-- print "[edit_items] hide"
	window_edit_items_list:setVisible( false )
	window_edit_items_data:setVisible( false )
end

function edit_items:show()
	-- print "[edit_items] show"
	self:updateList()

	window_edit_items_list:setVisible( true )
	-- print "[edit_items] /show"
end

function edit_items:destroy()
	-- print "[edit_items] destroy"
	window_edit_items_list:destroy()
end

function edit_items:input()
	if sim:isGUI( "button_edit_items_add_pressed" ) then
		-- print("button_edit_items_add_pressed")
		window_edit_items_data:setVisible( true )
		self:showAdd()
	end
	if sim:isGUI( "button_edit_items_edit_pressed" ) then
		-- print("button_edit_items_edit_pressed")
		window_edit_items_data:setVisible( true )
		self:showEdit()
	end
	if sim:isGUI( "button_edit_items_delete_pressed" ) then
		-- print("button_edit_items_delete_pressed")
		self:delete()
	end	
	if sim:isGUI( "button_edit_items_save_pressed" ) then
		-- print("button_edit_items_save_pressed")
		self:save()
	end	
end

function edit_items:save()
	-- print("[edit_items] save")
	-- item_name, item_type, item_class, item_effect, item_graphic, item_stat, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp

	if self.mode == 1 then
		-- print("[edit_items] insert row")
		query = " INSERT INTO table_stats "
		query = query .. " ( stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp )"
		query = query .. "VALUES ( "
		query = query .. textfield_edit_items_atk:getText() .. ", "
		query = query .. textfield_edit_items_def:getText() .. ", "
		query = query .. textfield_edit_items_mov:getText() .. ", "
		query = query .. textfield_edit_items_rng:getText() .. ", "
		query = query .. textfield_edit_items_dam:getText() .. ", "
		query = query .. textfield_edit_items_drn:getText() .. ", "
		query = query .. textfield_edit_items_sp:getText() .. ", "
		query = query .. textfield_edit_items_hp:getText() .. " "
		query = query .. " ); SELECT last_insert_rowid()"
		-- print ( query )
		q = sql:exe( query )
		-- print("last_insert_rowid: " .. q:getData( 0 ) )

		stat_id = q:getData( 0 )
		sql:removeResult( q )

		query = " INSERT INTO table_items "
		query = query .. " ( item_name, item_type, item_class, item_effect, item_graphic, item_stat, item_level, item_rarity, item_value )"
		query = query .. "VALUES ( "
		query = query .. "'".. textfield_edit_items_name:getText() .. "', "
		query = query .. "'".. combobox_edit_items_type:getSelected()+1 .. "', "
		query = query .. "'".. textfield_edit_items_class:getText() .. "', "
		query = query .. "0 , "
		query = query .. "'".. textfield_edit_item_graphic:getText() .. "', "
		query = query .. "'".. textfield_edit_items_level:getText() .. "', "
		query = query .. "'".. textfield_edit_items_rarity:getText() .. "', "
		query = query .. "'".. textfield_edit_items_value:getText() .. "', "
			
		query = query .. stat_id .. " "

		query = query .. " )"

		-- print( query )
		sql:exe( query )
	else
		-- print("[edit_items] update row")
		query = "UPDATE table_stats SET "
		query = query .. " stat_attack = '" .. textfield_edit_items_atk:getText() .. "', "
		query = query .. " stat_defense = '" .. textfield_edit_items_def:getText() .. "', "
		query = query .. " stat_speed = " .. textfield_edit_items_mov:getText() .. ", "
		query = query .. " stat_range = " .. textfield_edit_items_rng:getText() .. ", "
		query = query .. " stat_damage = " .. textfield_edit_items_dam:getText() .. ", "
		query = query .. " stat_drain = " .. textfield_edit_items_drn:getText() .. ", "
		query = query .. " stat_sp = " .. textfield_edit_items_sp:getText() .. ", "
		query = query .. " stat_hp = " .. textfield_edit_items_hp:getText() .. " "
		query = query .. " WHERE stat_id = " .. stat_id
		
		-- print ( query )
		q = sql:exe( query )
		
		query = "UPDATE table_items SET "
		query = query .. " item_name = '" .. textfield_edit_items_name:getText() .. "', "
		query = query .. " item_type = '" .. combobox_edit_items_type:getSelected()+1 .. "', "
		query = query .. " item_class = '" .. textfield_edit_items_class:getText() .. "', "
		query = query .. " item_effect = 0, "
		query = query .. " item_graphic = '" .. textfield_edit_item_graphic:getText() .. "', "
		query = query .. " item_level = '" .. textfield_edit_items_level:getText() .. "', "
		query = query .. " item_rarity = '" .. textfield_edit_items_rarity:getText() .. "', "
		query = query .. " item_value = '" .. textfield_edit_items_value:getText() .. "', "
		query = query .. " item_stat = " .. stat_id

		query = query .. " WHERE item_id = " .. self.current_item_id
		-- print( query )
		sql:exe( query )
	end
	self:updateList()
end

function edit_items:delete()
	if listbox_edit_items:getSelected() == -1 then return nil end
	n = listbox_edit_items:getItem( listbox_edit_items:getSelected() )
	-- print("[edit_items] delete item : " .. n)
	
	query = "DELETE FROM table_items WHERE item_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if stat_id > 0 then 
		-- print("[edit_items] delete statline : " .. stat_id)
		query = "DELETE FROM table_stats WHERE stat_id = '" ..  stat_id .. "'"
		local q = sql:exe( query )
	end
	
	self:updateList()
end

function edit_items:showAdd()
	self.mode = 1
	-- print "[edit_items] showAdd"
	-- show confirmation
	textfield_edit_items_name:setText("")
	combobox_edit_items_type:setSelected( 0 )
	textfield_edit_items_class:setText( "0" )
	textfield_edit_item_graphic:setText( "0" )
	textfield_edit_item_level:setText( "0" )
	textfield_edit_item_rarity:setText( "0" )
	textfield_edit_item_value:setText( "0" )

	textfield_edit_items_atk:setText( "0" )
	textfield_edit_items_def:setText( "0" )
	textfield_edit_items_mov:setText( "0" )
	textfield_edit_items_rng:setText( "0" )
	textfield_edit_items_dam:setText( "0" )
	textfield_edit_items_drn:setText( "0" )
	textfield_edit_items_sp:setText( "0" )
	textfield_edit_items_hp:setText( "0" )
	stat_id = -1
end

function edit_items:showEdit()
	self.mode = 2
	-- print "[edit_items] showEdit"
	-- show confirmation

	n = listbox_edit_items:getItem( listbox_edit_items:getSelected() )
	-- print("[edit_items] edit item : " .. n)
	query = "SELECT item_name, item_type, item_class, item_effect, item_graphic, item_stat, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp, item_id, item_level, item_rarity, item_value FROM table_items LEFT JOIN table_stats on stat_id = item_stat WHERE item_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_items] name : " .. q:getData( 0 ) )
			textfield_edit_items_name:setText( q:getData( 0 ) )
		end
		if q:getData( 1 ) ~= nil then
			-- print ( q:getData( 1 ) )
			combobox_edit_items_type:setSelected( q:getData( 1 )-1 )
		end
		if q:getData( 2 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_items_class:setText( q:getData( 2 ) )
		end
		if q:getData( 3 ) ~= nil then -- item_effect
			-- print ( q:getData( 3 ) )
		end
		if q:getData( 4 ) ~= nil then
			textfield_edit_item_graphic:setText( q:getData( 4 ) )
		end
		if q:getData( 5 ) ~= nil then
			-- print ("[edit_items] statline ID : " ..  q:getData( 5 ) )
			stat_id = tonumber( q:getData( 5 ) )
		else
			stat_id = -1
		end
		
		if q:getData( 6 ) ~= nil then
			textfield_edit_items_atk:setText( q:getData( 6 ) )
		end
		if q:getData( 7 ) ~= nil then
			textfield_edit_items_def:setText( q:getData( 7 ) )
		end
		if q:getData( 8 ) ~= nil then
			textfield_edit_items_mov:setText( q:getData( 8 ) )
		end
		if q:getData( 9 ) ~= nil then
			textfield_edit_items_rng:setText( q:getData( 9 ) )
		end
		if q:getData( 10 ) ~= nil then
			textfield_edit_items_dam:setText( q:getData( 10 ) )
		end
		if q:getData( 11 ) ~= nil then
			textfield_edit_items_drn:setText( q:getData( 11 ) )
		end
		if q:getData( 12 ) ~= nil then
			textfield_edit_items_sp:setText( q:getData( 12 ) )
		end
		if q:getData( 13 ) ~= nil then
			textfield_edit_items_hp:setText( q:getData( 13 ) )
		end
		
		self.current_item_id = tonumber( q:getData( 14 ) )
		if q:getData( 15 ) ~= nil then
			textfield_edit_items_level:setText( q:getData( 15 ) )
		end
		if q:getData( 16 ) ~= nil then
			textfield_edit_items_rarity:setText( q:getData( 16 ) )
		end
		if q:getData( 17 ) ~= nil then
			textfield_edit_items_value:setText( q:getData( 17 ) )
		end		
	--[[
		textfield_edit_items_atk
		textfield_edit_items_def
		textfield_edit_items_mov
		textfield_edit_items_rng
		textfield_edit_items_hp
		textfield_edit_items_sp
		textfield_edit_items_dam
		textfield_edit_items_drn
	]]--
	end
end


function edit_items:showDelete()
	-- print "[edit_items] showDelete"
	-- show confirmation
end

function edit_items:updateList()
	-- print "[edit_items] updateList"
	listbox_edit_items:clear()
	statement = "SELECT item_name FROM table_items WHERE 0 = 0 ORDER BY item_type ASC, item_class ASC, item_name ASC"
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				listbox_edit_items:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
	window_edit_items_data:setVisible( false )
end

-- end of file