-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- item.lua

item = { ID = 0 }

-- print "[item]"

ITEM_TYPE_WEAPON     = 1
ITEM_TYPE_ARMOR      = 2
ITEM_TYPE_ACCESSORY  = 3
ITEM_TYPE_CONSUMABLE = 4
ITEM_TYPE_RELIC      = 5
ITEM_TYPE_LORE       = 6

-- creation
function item:new (o)
	-- print "[item] new item"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	self.item_id      = 0
	self.item_name    = "Default Item"
	self.item_graphic = "clear.png"	
	self.item_type    = 0
	self.item_class   = 0

	self.stat_attack  = 0
	self.stat_defense = 0
	self.stat_move    = 0
	self.stat_range   = 0
	self.stat_damage  = 0
	self.stat_drain   = 0
	self.stat_sp      = 0
	self.stat_hp      = 0

	o.parent_id = 0 -- character_id, container_id, or zone_id, depending on item type
	o.grid      = xcore.x2dpoint( 0, 0 ) -- can be used for tetris style inventory, or map position
	o.position  = xcore.x3dpoint( 0, 0, 0 )
	o.location  = xcore.x2dpoint( 0, 0 )

	self.item_uses     = 1
	self.used          = 0
	-- print "[item] /new item"
	return o
end

function item:destroy()
	-- TODO: remove prototype
	-- TODO: remove mesh?
	-- TODO: remove icon
end

function item:setType( n ) self.type = n end
function item:getType() return self.type end

function item:setTimesUsed( i ) self.times_used = i end
function item:getTimesUsed() return self.times_used end

function item:loadItem( n )
	-- print("[item] loadItem")
	self.item_id = n
	statement = " SELECT item_name, item_type, item_class, item_effect, item_graphic, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp  "
	statement = statement .. " FROM table_items "
	statement = statement .. " LEFT JOIN table_stats on stat_id = item_stat "
	statement = statement .. " WHERE item_id = " .. n
	-- print( statement )
	local q = sql:exe( statement )
	if q == nil then
		-- print(" row not found")
		self.name = "unknown"
	else
		if q:getData( 0 ) ~= nil then self.item_name = q:getData( 0 ) end
		if q:getData( 1 ) ~= nil then self.item_type = tonumber( q:getData( 1 ) ) end
		if q:getData( 2 ) ~= nil then self.item_class = tonumber( q:getData( 2 ) ) end
		if q:getData( 3 ) ~= nil then self.item_effect = tonumber( q:getData( 3 ) ) end
		if q:getData( 4 ) ~= nil then self.item_graphic = q:getData( 4 ) end
		if q:getData( 5 ) ~= nil then self.stat_attack  = tonumber( q:getData( 5 ) ) end
		if q:getData( 6 ) ~= nil then self.stat_defense = tonumber( q:getData( 6 ) ) end
		if q:getData( 7 ) ~= nil then self.stat_move    = tonumber( q:getData( 7 ) ) end
		if q:getData( 8 ) ~= nil then self.stat_range   = tonumber( q:getData( 8 ) ) end
		if q:getData( 9 ) ~= nil then self.stat_damage  = tonumber( q:getData( 9 ) ) end
		if q:getData( 10 ) ~= nil then self.stat_drain   = tonumber( q:getData( 10 ) ) end
		if q:getData( 11 ) ~= nil then self.stat_sp      = tonumber( q:getData( 11 ) ) end
		if q:getData( 12 ) ~= nil then self.stat_hp      = tonumber( q:getData( 12 ) ) end

		--[[
		print("[self.item_name: " .. self.item_name )
		print("[self.item_type: " .. self.item_type )
		print("[self.item_class: " .. self.item_class )
		print("[self.item_graphic: " .. self.item_graphic )
		print("[self.stat_attack: " .. self.stat_attack )
		print("[self.stat_defense: " .. self.stat_defense )
		print("[self.stat_move: " .. self.stat_move )
		print("[self.stat_range: " .. self.stat_range )
		print("[self.stat_damage: " .. self.stat_damage )
		print("[self.stat_drain: " .. self.stat_drain )
		print("[self.stat_sp: " .. self.stat_sp )
		print("[self.stat_hp: " .. self.stat_hp )
		]]--

		sql:removeResult(q)
	end
end

-- end of file