-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- manager.lua

manager = { ID = 0 }

-- creation
function manager:new (o)
	-- print "[manager] new manager"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	-- print "[state_game] add control device"
	-- hmm. this 
	control_target = {}

	control_target[0] = sim:addCubeMesh( 0 )
	control_target[0]:addTexture( path .. "resources/interface/reticle_blue.png", 0)
	-- control_target:setMaterialFlag( xcore.XMF_WIREFRAME, true )
	control_target[0]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	control_target[0]:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )	
	control_target[0]:setScale( xcore.x3dpoint(1, 0, 1) )
	control_target[0]:setPosition( xcore.x3dpoint(0, 0, 0) )
	control_target[0]:setVisible(false)
	
	control_target[1] = sim:addCubeMesh( 0 )
	control_target[1]:addTexture( path .. "resources/interface/reticle_move.png", 0)
	control_target[1]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	control_target[1]:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )	
	control_target[1]:setScale( xcore.x3dpoint(1, 0, 1) )
	control_target[1]:setPosition( xcore.x3dpoint(0, 0, 0) )
	control_target[1]:setVisible(false)

	control_target[2] = sim:addCubeMesh( 0 )
	control_target[2]:addTexture( path .. "resources/interface/reticle_select.png", 0)
	control_target[2]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	control_target[2]:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )	
	control_target[2]:setScale( xcore.x3dpoint(1, 0, 1) )
	control_target[2]:setPosition( xcore.x3dpoint(0, 0, 0) )
	control_target[2]:setVisible(false)

	control_target[3] = sim:addCubeMesh( 0 )
	control_target[3]:addTexture( path .. "resources/interface/reticle_target.png", 0)
	control_target[3]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	control_target[3]:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )
	control_target[3]:setScale( xcore.x3dpoint(1, 0, 1) )
	control_target[3]:setPosition( xcore.x3dpoint(0, 0, 0) )
	control_target[3]:setVisible(false)

	control_target[4] = sim:addCubeMesh( 0 )
	control_target[4]:addTexture( path .. "resources/interface/reticle_target_done.png", 0)
	control_target[4]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	control_target[4]:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )	
	control_target[4]:setScale( xcore.x3dpoint(1, 0, 1) )
	control_target[4]:setPosition( xcore.x3dpoint(0, 0, 0) )
	control_target[4]:setVisible(false)

	control_surface = sim:addCubeMesh( 666 )
	control_surface:addTexture( path .. "resources/interface/clear.png", 0)
	control_surface:setMaterialFlag( xcore.XMF_LIGHTING, false )
	control_surface:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )
	control_surface:setScale( xcore.x3dpoint(100, 0.01, 100) )
	control_surface:setPosition( xcore.x3dpoint( 0, 0.02, 0 ) )
	control_surface:createTriangleSelector()

	selection_indicator = sim:addBillboard ( 0, xcore.x2dpoint(4, 4) )
	selection_indicator:addTexture(  path .. "resources/interface/selection_indicator.png", 0 )
	selection_indicator:setMaterialFlag( xcore.XMF_LIGHTING, false )	
	selection_indicator:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )		
	selection_indicator:setPosition( xcore.x3dpoint( 0, 32, 0 ) )
	selection_indicator:setVisible(false)

	exit_indicator = sim:addBillboard ( 0, xcore.x2dpoint(12, 8) )
	exit_indicator:addTexture(  path .. "resources/interface/exit.png", 0 )
	exit_indicator:setMaterialFlag( xcore.XMF_LIGHTING, false )	
	exit_indicator:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )		
	exit_indicator:setPosition( xcore.x3dpoint( 0, 12, 0 ) )
	exit_indicator:setVisible(false)

	start_indicator = sim:addBillboard ( 0, xcore.x2dpoint(12, 8) )
	start_indicator:addTexture(  path .. "resources/interface/start.png", 0 )
	start_indicator:setMaterialFlag( xcore.XMF_LIGHTING, false )	
	start_indicator:setMaterialType( xcore.XMT_TRANSPARENT_ALPHA_CHANNEL )		
	start_indicator:setPosition( xcore.x3dpoint( 0, 12, 0 ) )
	start_indicator:setVisible(false)
	
	cursor_map_tile_old = xcore.x2dpoint( 0,0 )
	cursor_map_tile = xcore.x2dpoint( 0,0 )

	endcap = {}
	endcap[1] = sim:addMesh ( 0,  path .. "resources/models/block.obj" )
	-- endcap[1]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	endcap[1]:setScale( xcore.x3dpoint( 1000, 6, 5 ) )
	endcap[1]:setPosition( xcore.x3dpoint(-0, -1000, -0 ) )

	endcap[2] = sim:addMesh ( 0,  path .. "resources/models/block.obj" )
	-- endcap[2]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	endcap[2]:setScale( xcore.x3dpoint( 1000, 6, 5 ) )
	endcap[2]:setPosition( xcore.x3dpoint(-0, -1000, -0 ) )

	endcap[3] = sim:addMesh ( 0,  path .. "resources/models/block.obj" )
	-- endcap[3]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	endcap[3]:setScale( xcore.x3dpoint( 5, 6, 1000 ) )
	endcap[3]:setPosition( xcore.x3dpoint(-0, -1000, -0 ) )

	endcap[4] = sim:addMesh ( 0,  path .. "resources/models/block.obj" )
	-- endcap[4]:setMaterialFlag( xcore.XMF_LIGHTING, false )
	endcap[4]:setScale( xcore.x3dpoint( 5, 6, 1000 ) )
	endcap[4]:setPosition( xcore.x3dpoint(-0, -1000, -0 ) )
	
	-- add the light ov the sun
	-- light = sim:addLight( 777, xcore.x3dpoint( 50, 50, 50 ), xcore.xcolour( 255, 255, 255, 255 ), 150 )
	-- sim:setAmbientLight( xcore.xcolour( 255, 20, 20, 20 ) )
	
	return o
end

function manager:update ()
	-- print "[manager] update"
	-- update pointer
	local p = sim:getIntersection( xcore.x2dpoint( mousex, mousey),  666 )

	if p.X == 0 and p.Y == 0 then
		-- print "null, mostly"
		-- debugtext:setText( "You see the sky" )
	else
		-- print "not null"
		cursor_pixel = p
		cursor_map_tile_old = cursor_map_tile
		cursor_map_tile = getMapTileFromPoint( xcore.x2dpoint (p.X, p.Z) ) -- this gets map tile
		
		if cursor_map_tile.X < 1 then cursor_map_tile.X = 1 end
		if cursor_map_tile.Y < 1 then cursor_map_tile.Y = 1 end
		if cursor_map_tile.X > map_size then cursor_map_tile.X = map_size end
		if cursor_map_tile.Y > map_size then cursor_map_tile.Y = map_size end
		if cursor_map_tile.X ~= cursor_map_tile_old.X or cursor_map_tile.Y ~= cursor_map_tile_old.Y then
			-- print("find path")
			-- game_map:clearLabels()
			-- findPath( cam_target, cursor_map_tile )
			-- game_map:drawPath()
		end
		
		cursor_mob = getMobIndexAtGrid( cursor_map_tile )
		
		if cursor_mob ~= nil then
			-- print( "mob at cursor position" )
		else
			cursor_mob = -1
		end
		-- print( "cursor position: " .. p.X .."," .. p.Z .." \n" )

		control_target[0]:setPosition( xcore.x3dpoint( cursor_map_tile.X* tile_size, 0.2, cursor_map_tile.Y* tile_size ) )
		control_target[1]:setPosition( xcore.x3dpoint( cursor_map_tile.X* tile_size, 0.2, cursor_map_tile.Y* tile_size ) )
		control_target[2]:setPosition( xcore.x3dpoint( cursor_map_tile.X* tile_size, 0.2, cursor_map_tile.Y* tile_size ) )
		control_target[3]:setPosition( xcore.x3dpoint( cursor_map_tile.X* tile_size, 0.2, cursor_map_tile.Y* tile_size ) )
		control_target[4]:setPosition( xcore.x3dpoint( cursor_map_tile.X* tile_size, 0.2, cursor_map_tile.Y* tile_size ) )		

		if phase > -1 then 
			if cursor_mob ~= -1  then
				if game_map.mobs[ cursor_mob ].owner_id == 1 then
					if game_map.mobs[ cursor_mob ].state == STATE_DONE then
						control_target[0]:setVisible( false )
						control_target[1]:setVisible( false )
						control_target[2]:setVisible( true )
						control_target[3]:setVisible( false )
						control_target[4]:setVisible( false )
					else
						control_target[0]:setVisible( false )
						control_target[1]:setVisible( true )
						control_target[2]:setVisible( false )
						control_target[3]:setVisible( false )
						control_target[4]:setVisible( false )
					end			
				else
					if game_map.mobs[ cursor_mob ].state == STATE_DONE then
						control_target[0]:setVisible( false )
						control_target[1]:setVisible( false )
						control_target[2]:setVisible( false )
						control_target[3]:setVisible( true )
						control_target[4]:setVisible( false )
					else
						control_target[0]:setVisible( false )
						control_target[1]:setVisible( false )
						control_target[2]:setVisible( false )
						control_target[3]:setVisible( false )
						control_target[4]:setVisible( true )
					end
				end
			else
				control_target[0]:setVisible( true )
				control_target[1]:setVisible( false )
				control_target[2]:setVisible( false )
				control_target[3]:setVisible( false )
				control_target[4]:setVisible( false )
			end			
		else
			control_target[0]:setVisible( false )
			control_target[1]:setVisible( false )
			control_target[2]:setVisible( false )
			control_target[3]:setVisible( false )
			control_target[4]:setVisible( false )
		end
		-- update control_selector 's pos
		indicator_height = -10
		if selected == nil then
			-- print("[manager] nil selected")
			selected = -1
			return nil
		end
		
		if selected > 0 then
			local p = xcore.x3dpoint(0, 0, 0)
			p = game_map.mobs[ selected ].position
			indicator_height = 12
			selection_indicator:setVisible( true )
			selection_indicator:setPosition( xcore.x3dpoint( p.X, p.Y+indicator_height, p.Z) )
		else
			selection_indicator:setVisible( false )
		end
	end
	
	
	-- turn data
	info_text = ""
	info_text = info_text .. "Stage: " .. dungeon_level .."/" .. map_depth .."\n"
	info_text = info_text .. "Turn: " .. turn .."\n"
	info_text = info_text .. "Rounds: ".. current_round .."/" .. rounds .."\n\n"

	-- set the text
	text_game:setText( info_text )

	debug_text = ""
	if show_debug == 1 then
		debug_text = debug_text .. "data ---------------------- \n"
		if phase == 1 then
			debug_text = debug_text .. "Player Phase \n"
		else
			debug_text = debug_text .. "CPU Phase\n"
		end
		debug_text = debug_text .. "\n"

		debug_text = debug_text .. "allies: " .. allies .."\n"
		debug_text = debug_text .. "activated: " .. allies_activated .."\n"
		debug_text = debug_text .. "ready: " .. allies_ready .."\n"
		debug_text = debug_text .. "progress: " .. allies_in_progress .."\n"
		debug_text = debug_text .. "defeated: " .. allies_defeated .."\n"
		debug_text = debug_text .. "exited: " .. allies_exited .."\n"
		debug_text = debug_text .. "acts: " .. allied_activations .."\n\n"

		debug_text = debug_text .. "enemies: " .. enemies .."\n"
		debug_text = debug_text .. "activated: " .. enemies_activated .."\n"
		debug_text = debug_text .. "ready: " .. enemies_ready .."\n"
		debug_text = debug_text .. "progress: " .. enemies_in_progress .."\n"
		debug_text = debug_text .. "defeated: " .. enemies_defeated .."\n"
		debug_text = debug_text .. "acts: " .. enemy_activations .."\n\n"
		
		if selected~= nil then debug_text = debug_text .. "selected: " .. selected .."\n"	end
		if target_index~= nil then debug_text = debug_text .. "target_index: " .. target_index .."\n"	end
		
		if selected ~= -1 then
			debug_text = debug_text .. "\nmob_face:" .. getDir( game_map.mobs[ selected ].mob_face ) .. "\n"
			debug_text = debug_text .. "cam_facing:" .. getDir( cam_facing ) .. "\n"
			debug_text = debug_text .. "ani_face:" .. getDir( game_map.mobs[ selected ].ani_face ) .. "\n"
		end
	elseif show_debug == 2 then
		debug_text = debug_text .. "nodes ---------------------- \n"
		for i = 1, table.getn( game_map.nodes ) do
			debug_text = debug_text .. i .. ") " .. game_map.nodes[i].name .. "\n"
		end
	elseif show_debug == 3 then
		debug_text = debug_text .. "mobs ---------------------- \n"
		for i = 1, table.getn( game_map.mobs ) do
			debug_text = debug_text .. game_map.mobs[i].name .. " (" .. game_map.mobs[i].class_name ..  ") \n"
			
			for n = 1, table.getn( game_map.mobs[ i ].special_abilities ) do
				if game_map.mobs[ i ].level >= game_map.mobs[ i ].special_abilities[ n ].ability_level then
					debug_text = debug_text ..  n .. ") " .. game_map.mobs[ i ].special_abilities[ n ].ability_name  .. "\n" 
				end
			end
		end
	elseif show_debug == 4 then
		debug_text = debug_text .. "stats ---------------------- \n"
		debug_text = debug_text .. "FPS: " .. sim:getFPS()
	end
	
	text_debug:setText( debug_text )
	
	-- print "[manager]/ update"
end

function manager:show()
	control_target[0]:setVisible( true )
	control_target[1]:setVisible( false )
	control_target[2]:setVisible( false )
	
end

function manager:hide()
	control_target[0]:setVisible( false )
	control_target[1]:setVisible( false )
	control_target[2]:setVisible( false )
	start_indicator:setVisible( false )
	exit_indicator:setVisible( false )
	selection_indicator:setVisible( false )
end

-- eof