-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- state_intro.lua

state_intro = state:new()

-- print "[state_intro]"

-- creation
function state_intro:new (o)
	-- print "[state_intro] new state_intro"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0

	width = 512
	height = 256	
	btn_w = 200
	btn_h = 40
	x = screen_width/2-(width/2)
	y = screen_height/2 -(height/2)

	text1 = [[In the 1351st year of the Pan-Gaian Empire, the high wizard Mirak, Supreme Magister of the school of Mages, removed from it's resting place in the Imperial palace The Phylactery of Axiam. With this artifact, said to posses power over death, he kidnapped Lady Aethyta, Princess of royal house and heir to the eastern Kingdom, and fled the city. In his path he ravaged the land, leaving a trail of corpses in his wake. Eventually the Wizard came to the city of Kzad-namloch, and there beneath the ruins he took to lair; a place that quickly became known throughout the land as the 'Dungeon of Death'.]]

	text2 = [[ Now, by order of the Immortal Dragon Emperor himself, a group of newly trained adventurers, unknown in name and title, have been heralded together as instruments with which to combat this threat. You are an Imperial Dragon Knight, raised from birth to worship the Immortal Emperor as a living God. As the leader of this band of heroes, it is your task to slay the foul Necromancer, rescue the princess, and recover the Phylactery... or die in the attempt. Before you stands the greatest challenge you have ever faced; behind you stand your allies; the fearless warriors and mighty wizards you have brought together and trained to aid you in your purpose.]]

	text3 = "The hour of destiny has come. For the sake of us all, go forth bravely and prevail!"
	
	text_intro = sim:addText( 0, text1, x, y, x+width, y+height)
	text_intro:setVisible( false )
	text_intro:setAlignment( 2, 0 )
	
	btn_w = 200
	btn_h = 40
	
	x = screen_width/2-(btn_w/2)
	y = screen_height-100
	-- add some buttons
	button_intro_exit = sim:addButton( 901, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Next" )
	button_intro_exit:setVisible( false )
	button_intro_exit:setImage( button_texture )
	button_intro_exit:setPressedImage( button_pressed_texture )
	
	-- bind events to actions.
	sim:bindGUI ( "button_intro_exit_pressed", 901, xcore.XGUI_BUTTON_CLICKED )

	self.step = 1
	
	return o
end

-- called on state_intro enter
function state_intro:enter ()
	-- print "[state_intro] enter state_intro"
	-- print("Show List")
	-- enter data into high score list
	self:show()
end

function state_intro:hide()
	text_intro:setVisible( false )
	button_intro_exit:setVisible( false )
	logo_image:setVisible( false )
	image_background:setVisible( false )
	-- text_title:setVisible( false )
	-- text_title:setText( "Intro" )
	-- image_background_title:setVisible( false )
	
end


function state_intro:show()
	text_intro:setVisible( true )
	button_intro_exit:setVisible( true )
	logo_image:setVisible( true )
	-- text_title:setVisible( false )
	-- text_title:setText( "Intro" )
	-- image_background_title:setVisible( false )
	if self.step == 1 then
		text_intro:setText( text1 )
	elseif self.step == 2 then
		text_intro:setText( text2 )
	elseif self.step == 3 then
		text_intro:setText( text3 )
	end
	
end

-- called on state_intro exit
function state_intro:exit ()
	-- print "[state_intro] exit state_intro"
	self:hide()
end

-- called to advance state_intro
function state_intro:input ()
	-- self.time = self.time + 1
	sim:update()
	r = ENUM_INTRO
	if sim:isGUI( "button_intro_exit_pressed" ) then
		if self.step == 1 then
			self.step = 2
			self:show()
		elseif self.step == 2 then
			self.step = 3
			self:show()
		else
		
			-- add the starter mob to the db
			statement = 			 " INSERT INTO table_characters "
			statement = statement .. " ( character_name, character_owner_id, character_class, character_level, character_hp, character_sp ) "
			statement = statement .. " VALUES ( 'Hiro', 1, 16, 1, 8, 4 )"
			sql:exe( statement )
			
			map_level_min = 1
			map_level_max = 1
			map_reward    =  100
			map_size =  12
			map_type = TILESET_CASTLE
			map_depth = 1
			map_sequence = 0
			
			r = ENUM_GAME

			-- r = ENUM_STRATEGY
		end
	end
	return r
end

-- called when changing state_intro
function state_intro:transition ( i ) -- transition to state_intro v
end
