-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- state_menu.lua

state_menu = state:new()

-- creation
function state_menu:new (o)
	-- print "[state_menu] new state_menu"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0

	-- set a few textures to use
	button_texture = sim:getTexture( path .. "resources/interface/button.png" )
	button_pressed_texture = sim:getTexture( path .. "resources/interface/button_pressed.png" )
	button_small_texture = sim:getTexture( path .. "resources/interface/button_small.png" )
	button_small_pressed_texture = sim:getTexture( path .. "resources/interface/button_small_pressed.png" )		
	texture_background = sim:getTexture( path .. "/resources/interface/background.png" )
	texture_background_128x256 = sim:getTexture( path .. "/resources/interface/frame_128x256.png" )
	texture_background_512x512 = sim:getTexture( path .. "/resources/interface/frame_512x512.png" )
	
	texture_background_title = sim:getTexture( path .. "/resources/interface/titlebar.png" )
	texture_background_icon = sim:getTexture( path .. "/resources/interface/frame_icon.png" )

	button_left_texture = sim:getTexture( path .. "resources/interface/button_left.png" )
	button_left_pressed_texture = sim:getTexture( path .. "resources/interface/button_left_pressed.png" )	
	button_right_texture = sim:getTexture( path .. "resources/interface/button_right.png" )
	button_right_pressed_texture = sim:getTexture( path .. "resources/interface/button_right_pressed.png" )	

	btn_w = 128
	btn_h = 30
	space = btn_w + 4
	x = screen_width/2-139
	y = screen_height/2-200
	
	image_background_title = sim:addImage( 0, texture_background_title, xcore.x2dpoint(x, y),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	text_title = sim:addText( 0, "",  x, y, x+278, y+20 )
	text_title:setAlignment( 2, 2 )

	x = 0
	y = screen_height-530
	-- add a castle!
	image_background = sim:addImage( 0, texture_background, xcore.x2dpoint(x, y),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	
	-- add a logo
	x = screen_width/2-200
	y = screen_height/2-220	
	logo_texture = sim:getTexture( path .. "resources/interface/logo_small.png" )
	logo_image = sim:addImage( 0, logo_texture, xcore.x2dpoint(x, y),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )

	x = screen_width/2-(btn_w/2)
	y = y + 100-- screen_height/2-160
	-- add some buttons
	button_menu_continue = sim:addButton( 102, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Continue" )
	button_menu_continue:setImage( button_texture )
	button_menu_continue:setPressedImage( button_pressed_texture )	
	y = y+ 50	
	button_menu_new = sim:addButton( 101, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "New Game" )
	button_menu_new:setImage( button_texture )
	button_menu_new:setPressedImage( button_pressed_texture )
	y = y+ 50
	button_menu_options = sim:addButton( 103, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Options" )
	button_menu_options:setImage( button_texture )
	button_menu_options:setPressedImage( button_pressed_texture )	
	y = y+ 50
	button_menu_about = sim:addButton( 104, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "About" )
	button_menu_about:setImage( button_texture )
	button_menu_about:setPressedImage( button_pressed_texture )	
	y = y+ 50
	button_menu_edit = sim:addButton( 106, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_menu_edit:setImage( button_texture )
	button_menu_edit:setPressedImage( button_pressed_texture )	
	y = y+ 50	
	button_menu_quit = sim:addButton( 105, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Quit" )
	button_menu_quit:setImage( button_texture )
	button_menu_quit:setPressedImage( button_pressed_texture )

	
	
	x = screen_width/2-139
	y = screen_height/2-200
	-- text

	text_menu_warning = sim:addText( 0, "Warning! Do you really want to erase all saved data? This action can not be undone.", x, y, x+256-8, y+48)
	text_menu_warning:setAlignment(2, 0)
	text_menu_warning:setVisible( false )
	
	y = y+ 60

	-- add some buttons
	button_menu_accept = sim:addButton( 107, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Yes" )
	button_menu_accept:setImage( button_texture )	
	button_menu_accept:setPressedImage( button_pressed_texture )	
	button_menu_accept:setVisible( false )

	x = x+ 128
	button_menu_cancel = sim:addButton( 108, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "No" )
	button_menu_cancel:setImage( button_texture )
	button_menu_cancel:setPressedImage( button_pressed_texture )	
	button_menu_cancel:setVisible( false )

	-- load sounds
	loadSounds()

	-- bind events to actions.
	sim:bindGUI ( "button_menu_new_pressed", 101, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_menu_continue_pressed", 102, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_menu_options_pressed", 103, xcore.XGUI_BUTTON_CLICKED )	
	sim:bindGUI ( "button_menu_about_pressed", 104, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_menu_quit_pressed", 105, xcore.XGUI_BUTTON_CLICKED )	
	sim:bindGUI ( "button_menu_edit_pressed", 106, xcore.XGUI_BUTTON_CLICKED )	

	sim:bindGUI ( "button_menu_accept_pressed", 107, xcore.XGUI_BUTTON_CLICKED )	
	sim:bindGUI ( "button_menu_cancel_pressed", 108, xcore.XGUI_BUTTON_CLICKED )	
	
	return o
end

-- called on state_menu enter
function state_menu:enter ()
	-- print "[state_menu] enter state_menu"
	-- show everything
	self:show()
	image_background:setVisible( true )
	game_camera:reset()
end

function state_menu:show()	
	button_menu_new:setVisible( true )
	button_menu_about:setVisible( true )
	
	statement =             " SELECT character_id FROM table_characters WHERE character_owner_id = 1 "
	local q = sql:exe( statement )
	if q ~= nil then
		button_menu_continue:setVisible( true )
		self.newgame = 0		
	else
		self.newgame = 1
		button_menu_continue:setVisible( false )
	end
	
	button_menu_options:setVisible( true )
	button_menu_quit:setVisible( true )
	button_menu_edit:setVisible( true )
	
	button_menu_accept:setVisible( false )
	button_menu_cancel:setVisible( false )
	text_menu_warning:setVisible( false )
	
	text_title:setVisible( true )
	-- text_title:setText( "Dungeon Tactics" )
	text_title:setText( "" )
	image_background_title:setVisible( false )
	logo_image:setVisible( true )

	text_debug:setText( "Version " .. version )
	text_debug:setVisible( true )
	text_debug:setFont( font )
	
	-- snd:clear()
	if snd:isPlaying( sound_menu_theme ) == false then
		snd:playSource( sound_menu_theme )
	end

	game_camera:reset()

end

-- called on state_menu exit
function state_menu:exit ()
	-- print "[state_menu] exit state_menu"
	-- hide everything
	self:hide()
end

function state_menu:hide ()
	button_menu_new:setVisible( false )
	button_menu_about:setVisible( false )
	button_menu_continue:setVisible( false )
	button_menu_options:setVisible( false )
	button_menu_quit:setVisible( false )
	button_menu_edit:setVisible( false )
	
	button_menu_accept:setVisible( false )
	button_menu_cancel:setVisible( false )
	text_menu_warning:setVisible( false )
	
	text_title:setVisible( true )
	text_title:setText( "" )
	image_background_title:setVisible( false )
	logo_image:setVisible( false )
end

-- called to advance state_menu
function state_menu:input ()
	-- print ( "[state_menu] input")
	sim:update()
	
	r = ENUM_MENU
	if sim:isGUI( "button_menu_quit_pressed" ) then sim:destroy() end -- sim:destroy()
	if sim:isGUI( "button_menu_continue_pressed" ) then r = ENUM_STRATEGY end
	if sim:isGUI( "button_menu_options_pressed" ) then r = ENUM_OPTIONS end
	if sim:isGUI( "button_menu_about_pressed" ) then r = ENUM_ABOUT end	
	if sim:isGUI( "button_menu_edit_pressed" ) then r = ENUM_EDIT end
	-- if sim:isGUI( "button_menu_scores_pressed" ) then r = ENUM_SCORES end
	if sim:isGUI( "button_menu_new_pressed" ) then
		if self.newgame == 0 then
			self:hide()
			self:showWarning()
		else
			self:newGame()
		end
	end

	if sim:isGUI( "button_menu_accept_pressed" ) then
		-- print("[state_menu] button_menu_accept_pressed")
		self:show()		
		self:newGame()
	end

	if sim:isGUI( "button_menu_cancel_pressed" ) then
		self:show()
	end

	-- print("update sound...")
	snd:setListenerPosition( 0, 0, 0 )
	snd:setSourcePosition( sound_menu_theme, 0, 0, 0) -- xcore.x3dpoint( 0, 0, 0 ) 
	snd:update()
	-- print("/ update sound")
	return r
end

function state_menu:showWarning()
	button_menu_accept:setVisible( true )
	button_menu_cancel:setVisible( true )
	text_menu_warning:setVisible( true )

end

function state_menu:newGame()
	-- print("[state_menu] newgame")
	-- start new game!
	-- delete inventory
	statement = " DELETE FROM table_inventory WHERE 0 = 0 "
	sql:exe( statement )
	-- delete characters
	statement = " DELETE FROM table_characters WHERE 0 = 0 "
	sql:exe( statement )
	-- reset user
	statement = "UPDATE table_users SET user_gold = 100, user_sequence = 0 WHERE user_id = 1 "
	sql:exe( statement )

	-- load tutorial level and go directly into state_game?
	r = ENUM_INTRO
end

-- called when changing state_menu
function state_menu:transition ( i ) -- transition to state_menu v
	-- print "[state_menu] transition"
	-- if self.time > 50 then print "..." end
end
