-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- summary.lua

summary = { ID = 0 }

-- print "[summary]"

-- creation
function summary:new (o)
	-- print "[summary] new summary"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	-- what about gui text elements?
	width = 262
	height = 300
	btn_w = 128
	btn_h = 30
	x = screen_width/2-(262/2)
	y = screen_height/2-150

	-- text

	image_background_summary = sim:addImage( 0, texture_background_512x512, xcore.x2dpoint(x, y),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	x = x+4
	y = y+4
	
	text_summary = sim:addText( 0, "Testing!!!!", x, y, x+(width-20), y+(height))
	text_summary:setAlignment(2, 0)

	btn_w = 200
	btn_h = 30
	
	x = screen_width/2-(btn_w/2)
	y = screen_height-128
	-- add some buttons
	button_summary_accept = sim:addButton( 601, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Next" )
	button_summary_accept:setImage( button_texture )
	button_summary_accept:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_summary_accept_pressed", 601, xcore.XGUI_BUTTON_CLICKED )

	width = 96
	height = 30
	x = screen_width/2+110
	y = screen_height/2-154

	self.visible = 1
	self:hide()
	return o
end

function summary:hide()
	-- print "[summary] hide"
	image_background_title:setVisible( false )
	text_title:setText("")
	self.visible = 0
	text_title:setVisible( false )		
	image_background_summary:setVisible( false )	
	text_summary:setVisible( false )	
	button_summary_accept:setVisible( false )
end

function summary:show()
	-- print "[summary] show"
	self:update()
	self.visible = 1
	image_background_title:setVisible( true )	
	text_title:setText("Level Summary")
	text_title:setVisible( true )	
	image_background_summary:setVisible( true )	
	text_summary:setVisible( true )	
	button_summary_accept:setVisible( true )

	control_target[0]:setVisible( false )
	control_target[1]:setVisible( false )
	control_target[2]:setVisible( false )
	control_target[3]:setVisible( false )
	control_target[4]:setVisible( false )	
end

function summary:destroy()
	-- print "[summary] destroy"
	
end

function summary:update()
	-- print "[summary] update unit summary"
	--[[
	n = 0
	for i = 1, table.getn( game_map.mobs ) do
		if game_map.mobs[ i ].owner_id == 1 then
			n = n +1
			-- print("i :" .. i )
			tmp_exp = game_map.mobs[ i ].exp
			tmp_lvl = game_map.mobs[ i ]:getEXPToLevel( game_map.mobs[ i ]:getLevel()+1 )
			tmp_ttl = tmp_lvl - tmp_exp

			if n < 5 then
				if game_map.mobs[ i ].state == STATE_KILLED then
					text_unit_summary[ n ]:setText("")
					image_summery_thumbnails[ n ]:setImage( sim:getTexture( path .. "resources/interface/icon_dead.png" ) )
				else
					if game_map.mobs[ i ].level ~= game_map.mobs[ i ]:getLevel() then
						text_unit_summary[ n ]:setText("LEVEL UP")
					else
						text_unit_summary[ n ]:setText("NEXT " .. tmp_ttl)
					end
					
					image_summery_thumbnails[ n ]:setImage( sim:getTexture( path .. "resources/sprites/icon_" .. game_map.mobs[ i ].graphic .. ".png" ) )
				end
			end
		end
	end
	]]--
	if allies_defeated + allies_exited == allies and allies_exited ~= 0 then
		summary_data = ""
		summary_data = summary_data .. "\nRetreated! \n\n\n\n"
		-- play sound effect
		snd:playSource( sound_lose )
		
	elseif allies_defeated < allies then
		summary_data = ""
		summary_data = summary_data .. "\nLevel " .. dungeon_level .."/" .. map_depth .." clear! \n\n\n\n"

		-- play sound effect
		snd:playSource( sound_win )
	else
		summary_data = ""
		summary_data = summary_data .. "\nLevel " .. dungeon_level .."/" .. map_depth .." Failed... \n\n\n\n"
		-- play sound effect
		snd:playSource( sound_lose )		
	end

	summary_data = summary_data .. "Turns  : " .. turn ..  "\n\n"
	summary_data = summary_data .. "Kills  : " .. enemies_defeated .. "\n\n"
	summary_data = summary_data .. "Deaths : " .. allies_defeated .. "\n\n"
	summary_data = summary_data .. "______________________\n\n"

	summary_data = summary_data .. "+ " .. math.floor( score / allies ) .. " EXP\n"
	summary_data = summary_data .. "+ " .. bonus .. " Gold \n\n"
	
	text_summary:setText( summary_data )
end

-- end of file