-- state_game object
-- lwi
-- ...

state_game = state:new()

print "[state_game]"

-- creation
function state_game:new (o)
	print "[state_game] new state_game"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0

	-- add text box (listbox for now), for messege  output
	x = 0
	y = 0
	-- textbox = sim:addTextbox( 0, xcore.x2drect( x,y,x+200,y+200 ) )
	listbox = sim:addListbox( 410, true, xcore.x2drect( x,y,x+250,y+100 ) )
	listbox:setVisible( false )

	-- add edit boxs for chat input
	x = 0
	y = 100
	editboxmessage = sim:addEditbox( 420,  xcore.x2drect( x,y,x+200,y+20 ) )
	editboxmessage:setVisible( false )

	-- add a button
	x = 200
	y = 100
	buttonsend    = sim:addButton( 430, xcore.x2drect( x, y, x+50, y+20 ), "send" )
	buttonsend:setVisible( false )

	-- textbox for score
	text_score = sim:addText( 0, "score", 650, 20, 800, 100)
	text_score:setVisible( false )
	
	-- add a static camera
	camera = sim:addCamera ( 0, xcore.CAMERA_STATIC, 0,0,200,  0,0,0) -- xcore.CAMERA_STATIC

	-- add key bindings; TODO: user defined keys via require "module.controls"
	sim:bindkey ( "move_left",  xcore.XKEY_LEFT  )
	sim:bindkey ( "move_right", xcore.XKEY_RIGHT )
	sim:bindkey ( "move_up",    xcore.XKEY_UP    )
	sim:bindkey ( "move_down",  xcore.XKEY_DOWN  )
	sim:bindkey ( "fire0",  xcore.XKEY_LCONTROL  )
	sim:bindkey ( "fire1",  xcore.XKEY_LSHIFT  )
	sim:bindkey ( "fire2",  xcore.XKEY_TAB  )
	sim:bindkey ( "quit",  xcore.XKEY_ESCAPE  )
	sim:bindkey ( "zoom_in",  xcore.XKEY_PLUS  )
	sim:bindkey ( "zoom_out",  xcore.XKEY_MINUS  )
	sim:bindGUI ( "send_button_pressed", 430, xcore.XGUI_BUTTON_CLICKED )

	-- print a graph to the console
	-- sim:printTree();

	zoom = 200

	-- add a skybox
	sky = sim:addSkybox(500, path .. "resources/starfield.jpg",
		path .. "resources/starfield.jpg",
		path .. "resources/starfield.jpg",
		path .. "resources/starfield.jpg",
		path .. "resources/starfield.jpg",
		path .. "resources/starfield.jpg")

	 -- add earth TODO: move to spawned object
	mesh_file = "modules/tutorial_physics_2/resources/earth.x"
	tex_file = "modules/tutorial_physics_2/resources/earthmap1k.jpg"
	mesh = sim:addMesh ( 2, mesh_file )
	mesh:addTexture(tex_file, 0)
	mesh:setScale( xcore.x3dpoint( 200, 200, 200 ) )
	np = xcore.x3dpoint( 300, -20, 0 )
	mesh:setPosition( np )
	mesh:setMaterialFlag( xcore.XMF_LIGHTING, false )

	objects = {}
	object_count = 0

	users = {}
	user_count = 0
	score = 0
	delay = 0
	sim:setKeyDelay( 25 )

	visual_effects = {}

	time = xcore.xtimer()

	showDebug = 0
	if showDebug == 1 then
		-- add annotations
		--     | Y
		--     |
		--     |
		--     |_________ X
		--    /
		--   /
		--  / Z
		-- x = red
		-- y = green
		-- z = blue
		line_x = sim:add3dLine ( 0, xcore.x3dpoint( 0, 0, 0 ), xcore.x3dpoint( 10, 0, 0 ) )
		line_x:setColour( xcore.xcolour( 255, 255, 0, 0 ) ) -- red
		line_y = sim:add3dLine ( 0, xcore.x3dpoint( 0, 0, 0 ), xcore.x3dpoint( 0, 10, 0 ) )
		line_y:setColour( xcore.xcolour( 255, 0, 255, 0 ) ) -- green
		line_z = sim:add3dLine ( 0, xcore.x3dpoint( 0, 0, 0 ), xcore.x3dpoint( 0, 0, 10 ) )
		line_z:setColour( xcore.xcolour( 255, 0, 0, 255 ) ) -- blue
	
		-- add debug text
		debugtext = sim:addText( 0, "debug text", 400, 400, 600, 600)
	
		-- add debug arrow
		dbg_line = sim:add3dLine ( 0, xcore.x3dpoint( 0, 0, 0 ), xcore.x3dpoint( 100, 0, 0 ) )
		dbg_line:setColour( xcore.xcolour( 255, 255, 0, 0 ) ) -- red
	end

	return o
end

-- called on state_game enter
function state_game:enter ()
	print "[state_game] enter state_game"
	self.time = 0
	-- create new game
	listbox:setVisible( true )
	editboxmessage:setVisible( true )
	text_score:setVisible( true )
	
	-- listboxusers:setVisible( true )
	buttonsend:setVisible( true )
	
	if showDebug == 1 then
		dbg_line:setVisible( true )
		debugtext:setVisible( true )
	end
end

-- called on state_game exit
function state_game:exit ()
	print "[state_game] exit state_game"
	self.time = 0
	-- clean up
	listbox:setVisible( false )
	editboxmessage:setVisible( false )
	-- listboxusers:setVisible( false )
	buttonsend:setVisible( false )
	text_score:setVisible( false )
	
	camera:setPosition( xcore.x3dpoint( 0, 0, 200 ) )
	camera:setTarget( xcore.x3dpoint( 0, 0, 0 )  )

	if showDebug == 1 then
		dbg_line:setVisible( false )
		debugtext:setVisible( false )
	end
	
	if alertbox ~= nil then
		alertbox:destroy()
		alertbox = nil
	end
	
	-- remove objects
	local object_count = table.getn( objects )
	for i=object_count,1,-1 do
		objects[i]:destroy()
		table.remove ( objects, i )
	end

	print "[state_game] /exit state_game"
end

-- called to advance state_game
function state_game:input ()
	-- print ( "[state_game] input" )

	r = self:doevents() -- update events

	sim:update()        -- update sim
	if net:update() ~= 1 then
		-- print ( "connection lost" )
		if alertbox == nil then
			alertbox = dialogbox:new()
			alertbox:addMessage("Connection Lost")
			alertbox:addButton("Exit", "dialog_connection_lost")
		end
	end        -- update network

	if delay > 0 then
		-- print ( "[pawn] delay =" .. self.delay )
		delay = delay - 1
	end
	
	time:update()
	-- print ("execution time:" .. time:getFactor() )

	lp = 0
	while lp == 0 do            -- infinite loop, continues while still messeges in que.
		packet = net:get()  -- get oldest message out ov que.
		if packet == nil then
			-- print "[client] no packets"
			lp = 1
		else
			-- print ( "[state_game] packet type : " .. tonumber( packet:getType() ) )
			ptype = packet:getType()
			if tonumber( ptype ) == xcore.XPACKET_MESSAGE then
				print "[client] add message"
				listbox:addItem( packet:getMessage() ) -- add message to text area.

			elseif tonumber( ptype ) == xcore.XPACKET_USER_JOIN then
				-- print "[state_game] packet add user"
				a = packet:getMessage()
				tmp = string.split( a, ";" )

				-- print (a)
				-- for index,value in pairs( tmp ) do
				-- 	print (index, value)
				-- end

				listbox:addItem(  tmp[3] .. " has connected." ) -- add message to text area.
				-- self:addUser( tmp[2], tmp[3], tmp[4] )

			elseif tonumber( ptype ) == xcore.XPACKET_USER_PART then
				print "[state_game] packet delete user"
				i = self:getUserIndexByID( packet:getMessage() )
				-- users[i] = nil
				table.remove ( users, i )
				self:refreshUserList()
				print "[state_game] user deleted"

			elseif tonumber( ptype ) == xcore.XPACKET_USER_UPDATE then
				print "\n\n[state_game] packet update user"
				-- create object, add to object array!
				a = packet:getMessage()
				tmp = string.split( a, ";" )
				print ( a )
				for index,value in pairs( tmp ) do
					print (index, value)
				end
				print ( " tmp1 " .. tmp[1] )
				print ( " tmp2 " .. tmp[2] )
				score = tmp[2]
			elseif tonumber( ptype ) == xcore.XPACKET_OBJECT_ADD then
				print "[state_game] packet add object"
				-- create object, add to object array!
				a = packet:getMessage()
				tmp = string.split( a, ";" )
				print ( a )
				for index,value in pairs( tmp ) do
					print (index, value)
				end
				self:addObject( tmp[1], tmp[2], tmp[3] )
				print "[state_game] /packet add object"

			elseif tonumber( ptype ) == xcore.XPACKET_OBJECT_DELETE then
				print "[state_game] packet delete object"
				i = self:getObjectIndexByID( packet:getMessage() )
				
				print ("type : " .. objects[i]:getType())
				if tonumber( objects[i]:getType() ) == 1 then
					print "spawn gfx effect"
					-- spawn gfx effect
					self:spawnEffect( 2, objects[i]:getPosition() )
				end
				
				objects[i]:destroy()
				-- objects[i] = nil
				table.remove ( objects, i )
				print "[state_game] object deleted"

			elseif tonumber( ptype ) == xcore.XPACKET_OBJECT_UPDATE then
				print "[state_game] packet update object"

			elseif tonumber( ptype ) == xcore.XPACKET_OBJECT_UPDATE_POSITION then
				-- print ( "[state_game] packet position" )
				-- move object by id.
				a = packet:getMessage()

				tmp = string.split( a, ";" )
				-- print ( a )
				for index,value in pairs( tmp ) do
					-- print (index, value)
				end

				o = self:getObjectIndexByID( tmp[1] )
				objects[o]:setPosition ( xcore.x3dpoint( tmp[2], tmp[3], tmp[4] ) )

				-- print "[state_game] end packet position"
			elseif tonumber( ptype ) == xcore.XPACKET_OBJECT_UPDATE_ROTATION then
				-- print ( "[state_game] packet rotation" )
				a = packet:getMessage()
	
				tmp = string.split( a, ";" )
				-- print ( a )
				for index,value in pairs( tmp ) do
					-- print (index, value)
				end
				--
				o = self:getObjectIndexByID( tmp[1] )
				objects[o]:setRotation ( xcore.x3dpoint( tmp[2], tmp[3], tmp[4] ) )
			else
				print ( "[client] unknown packet type: " ..packet:getType() )
			end
		end   -- exit the loop if the condition is true
	end

	-- print "check for expired visual effects"
	effect_count = table.getn( visual_effects )
	for i=effect_count,1,-1 do
		if visual_effects[i]:update() == 0 then
			visual_effects[i]:destroy()
			visual_effects[i] = nil
			table.remove ( visual_effects, i )
		end
	end
	
	-- update camera. put someplace better ( inside a nice camera object perhaps? )
	-- look at first object owned by user
	-- print "[state_game] update cam."
	i = self:getUserIndexByName( localusername )
	o = self:getObjectIndexByOwnerID( local_user_id )
	if o ~= nil then
		oid = objects[o]:getID()
		p = objects[ o ]:getPosition()
		rot = objects[ o ]:getRotation()

		camera:setTarget( p )
		camera:setPosition( xcore.x3dpoint( p.X, p.Y, p.Z-zoom ) )
	else
		-- user has no object. this means they are in the respawn que...
		print "[client] no object, waiting in respawn que."
	end
	
	if showDebug == 1 then
		dbg = "focused object id :" .. oid .. "\n"
		dbg = dbg .. "position :" .. p.X .. "," .. p.Y .. "," .. p.Z ..  "\n"
		dbg = dbg .. "rotation :" .. rot.X .. "," .. rot.Y .. "," .. rot.Z ..  "\n\n"
		dbg = dbg .. "----------------------------------------------------\n"		
		dbg = dbg .. "fps :" .. sim:getFPS() ..  "\n"
		dbg = dbg .. "tris :" .. sim:getTris() ..  "\n"		
		dbg = dbg .. "----------------------------------------------------\n"
		dbg = dbg .. "packets received :" .. net:getPacketsReceived() ..  "\n"
		dbg = dbg .. "packets sent :" .. net:getPacketsSent() ..  "\n"
		dbg = dbg .. "ping :" .. net:getPing() ..  "\n"		

		debugtext:setText( dbg )

		-- print "draw facing line"
		-- get the position
		vessel_pos = p
		
		-- get the rotation
		vessel_rot = rot
		
		m = xcore.xmatrix4()
		endpoint = xcore.x3dpoint( 0, 20, 0 )
		m:setRotationDegrees( vessel_rot )
		m:transformVect( endpoint )
		
		startpoint = vessel_pos
		endpoint.X = endpoint.X + startpoint.X
		endpoint.Y = endpoint.Y + startpoint.Y
		endpoint.Z = endpoint.Z + startpoint.Z
		-- print ("startpoint:" .. startpoint.X .. "," .. startpoint.Y .. "," .. startpoint.Z )
		-- print ("endline:" .. endline.X .. "," .. endline.Y .. "," .. endline.Z )

		-- update debug line
		dbg_line:setStart( startpoint )
		dbg_line:setEnd( endpoint )
		-- print "/draw facing line"
	end
	
	text_score:setText( "Score : ".. score )
	-- print ( "return : " .. r )

	return r
end

function state_game:spawnEffect( t, pos ) -- type, pos, rot
	local a = visual:new()
	local i = table.getn( visual_effects ) + 1
	-- print ( "[state_game] object :" .. i )
	-- print ( "[state_game] spawnObject id/index :" .. object_sequence .. "/" .. i )
	visual_effects[ i ] = a
	visual_effects[ i ]:setType ( t )
	visual_effects[ i ]:setPosition ( pos )
end

-- called when changing state_game
function state_game:transition ( i ) -- transition to state_game v
	print "[state_game] transition"
	-- if self.time > 50 then print "..." end
end

-- This is a custom function to show how to auto-handle events.
function state_game:doevents()
	-- print "[state_game] doevents"
	-- here you can get key presses by action.
	-- TODO: add a repeat delay/ outbound que and only send a few at a time, to avoid flooding packets

	if sim:isKeyPressed( "move_left" ) then
		net:send( xcore.XPACKET_OBJECT_UPDATE_POSITION, "1" )
	end

	if sim:isKeyPressed( "move_right" ) then
		net:send( xcore.XPACKET_OBJECT_UPDATE_POSITION, "2" )
	end

	if sim:isKeyPressed( "move_up" ) then
		net:send( xcore.XPACKET_OBJECT_UPDATE_POSITION, "3" )
	end

	if sim:isKeyPressed( "move_down" ) then
		net:send( xcore.XPACKET_OBJECT_UPDATE_POSITION, "4" )
	end

	if sim:isGUI( "dialog_connection_lost" ) then
		print "dialog_connection_lost"
		-- dismiss box
		return ENUM_MENU
	end

	if sim:isGUI( "dialogbox_accept" ) then
		-- dismiss box and exit
		return ENUM_MENU	
	end

	if sim:isGUI( "dialogbox_cancel" ) then
		-- dismiss box
		if alertbox ~= nil then
			alertbox:destroy()
			alertbox = nil
		end
	end

	if sim:isGUI( "send_button_pressed" ) then self.sendMessage() end
	if sim:isKey( "zoom_in" ) and zoom > 20 then zoom = zoom - 10 end
	if sim:isKey( "zoom_out" ) then zoom = zoom + 10 end

	if sim:isKeyPressed( "fire0" ) then
		if delay == 0 then
			delay = 50
			net:send( xcore.XPACKET_ACTION, "0" )
		end
	end
	-- if sim:isKey( "fire1" ) then net:send( xcore.XPACKET_ACTION, "1" ) end 
	-- if sim:isKey( "fire2" ) then net:send( xcore.XPACKET_ACTION, "2" ) end 
	-- if sim:isKey( "fire3" ) then net:send( xcore.XPACKET_ACTION, "3" ) end 

	if sim:isKey( "quit_key_pressed" ) then
		-- pop dialog askin if they want to quit
		-- return ENUM_MENU
		if alertbox == nil then
			alertbox = dialogbox:new()
			alertbox:addMessage("Do you really want to Quit?")
			alertbox:addButtons()
		end
	end
	return ENUM_GAME
end

-- send text message to server
function state_game:sendMessage()
	print "[state_game] send message"
	-- get text from xeditbox
	t = editboxmessage:getText()
	if t ~= nil then
		-- send via xnet object
		net:send( xcore.XPACKET_MESSAGE, t )
		-- clear xeditbox
		editboxmessage:setText("")
	end
end

function state_game:refreshUserList()
	print "[state_game] refreshUserList"
	-- listboxusers:clear()
	i = table.getn( users )
	for n = 1, i do
		-- listboxusers:addItem( users[ n ]:getName() ) -- add message to text area.
	end
end

function state_game:getObjectIndexByID( id ) -- owner, type, pos, rot
	-- print ("[state_game] getObjectIndexByID(" .. id .. ")" )
	i = table.getn( objects )
	-- print ("[state_game] object count :" .. i )
	for n = 1, i do
		-- print ("object #" .. n .. " ID:" .. objects[ n ]:getID() )
		if  objects[ n ]:getID() == id then
			-- print ( "[state_game] return " .. n )
			return n
		end
	end
	-- print "[state_game] error, returning null"
	return nil
end

function state_game:getUserIndexByID( id ) -- owner, type, pos, rot
	-- print ("[state_game] getUserIndexByID(" .. id .. ")" )
	i = table.getn( users )
	for n = 1, i do
		-- print ("object #" .. n .. " ID:" .. objects[ n ]:getID() )
		if  users[ n ]:getID() == id then
			-- print ( "[client] return " .. n )
			return n
		end
	end
	-- print "[state_game] error, returning null"
	return nil
end

-- this function is only used for cam
function state_game:getObjectIndexByOwnerID( oid ) -- owner, type, pos, rot
	-- print ("[state_game] getObjectIndexByOwner(" .. oid .. ")" )
	i = table.getn( objects )
	for n = 1, i do
		-- print ("object #" .. n .. " owner:" .. objects[ n ]:getOwner() )
		if tonumber( objects[ n ]:getType() ) == 1 then
			if  objects[ n ]:getOwner() == oid then
				-- print ( "[client] return " .. n )
				return n
			end
		end
	end
	-- print "[state_game] error, returning null"
	return nil
end

function state_game:getUserIndexByName( un ) -- owner, type, pos, rot
	-- print ( "[state_game] getUserIndexByName(" .. un .. ")" )
	i = table.getn( users )
	for n = 1, i do
		-- print ("user #" .. n .. " name:" .. users[ n ]:getName() )
		if  users[ n ]:getName() == un then
			-- print ( "[client] return " .. n )
			return n
		end
	end
	-- print "[state_game] error, returning null"
	return nil
end

function state_game:addUser( uid, un, us )
	print "[state_game] add user"
	i = table.getn( users ) + 1
	print ( "adding user to index" .. i )
	users[ i ] = user:new()
	users[ i ]:setID( uid )
	users[ i ]:setName( un )
	users[ i ]:setScore( us )
	-- listboxusers:addItem( un )
	-- print "/end"
end -- params?

function state_game:editUser() end

function state_game:deleteUser() end

function state_game:addObject( oid, ot, oo )
	print "[state_game] add Object"
	i = table.getn( objects ) + 1

	-- TODO: get object properties from prototype database.
	objects[ i ] = pawn:new()

	print ("[state_game] object index : " .. i )
	print ("[state_game] object type : " .. ot )
	print ("[state_game] object id : " .. oid )

	if ot == "1" then
		objects[ i ]:setGraphic ( "modules/shooter_client/resources/y25.x",
			"modules/shooter_client/resources/y25.tga" )
		objects[ i ]:setTrail()
	else
		-- make a bullet
		objects[ i ]:setGraphic ( "cube",
			"modules/shooter_client/resources/particleblue.bmp" )
		
	end

	objects[ i ]:setPosition ( xcore.x3dpoint(0, 0, 0 ) )
	objects[ i ]:setID ( oid )
	objects[ i ]:setType ( ot )
	objects[ i ]:setOwner ( oo )

	print "[state_game] object added"
end

function state_game:editObject() end

function state_game:deleteObject() end

-- Move this function into xlib
function string:split( delimiter )
	local result = { }
	local from  = 1
	local delim_from, delim_to = string.find( self, delimiter, from  )
	while delim_from do
		table.insert( result, string.sub( self, from , delim_from-1 ) )
		from  = delim_to + 1
		delim_from, delim_to = string.find( self, delimiter, from  )
	end
	table.insert( result, string.sub( self, from  ) )
	return result
end
