-- state_menu object
-- lwi
-- ...

state_menu = state:new()

print "[state_menu]"

-- creation
function state_menu:new (o)
	print "[state_menu] new state_menu"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0

	sim:setWindowCaption( "p-shooter client - xenjine Demo" )

	-- add some static text
	titletext = sim:addText( 0, "p-shooter client - xenjine Demo", 0, 0, 200, 12 )

	x = 100
	y = 100	
	-- add some buttons
	button_login  = sim:addButton( 101, xcore.x2drect( x, y, x+100, y+20 ), "Login" )
	y = y+25
	button_scores = sim:addButton( 102, xcore.x2drect( x, y, x+100, y+20 ), "High Scores" )
	y = y+25	
	button_quit   = sim:addButton( 103, xcore.x2drect( x, y, x+100, y+20 ), "Quit" )
	
	-- bind events to actions.
	sim:bindGUI ( "login_button_pressed", 101, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "high_scores_button_pressed", 102, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "quit_button_pressed", 103, xcore.XGUI_BUTTON_CLICKED )
	
	print "[state_menu] finish new state menu"
	return o
end

-- called on state_menu enter
function state_menu:enter ()
	print "[state_menu] enter state_menu"
	-- show everything
	-- w:setVisible( true )
	button_login:setVisible( true )
	button_scores:setVisible( true )
	button_quit:setVisible( true )
	titletext:setVisible( true )
	self.time = 0
end

-- called on state_menu exit
function state_menu:exit ()
	print "[state_menu] exit state_menu"
	-- hide everything
	-- w:setVisible( false )
	button_login:setVisible( false )
	button_scores:setVisible( false )
	button_quit:setVisible( false )
	titletext:setVisible( false )
	self.time = 0
end

-- called to advance state_menu
function state_menu:input ()
	-- print ( "[state_menu] input")
	self.time = self.time + 1

	r = ENUM_MENU -- 1
	-- act upon keypress and user interface events
	-- if sim:isKey( "quit_key_pressed" ) then sim:destroy() end
	if sim:isGUI( "quit_button_pressed" ) then sim:destroy() end -- sim:destroy()
	if sim:isGUI( "login_button_pressed" ) then r = ENUM_LOGIN end
	if sim:isGUI( "high_scores_button_pressed" ) then r = ENUM_HIGHSCORES end
	sim:update()

	return r
end

-- called when changing state_menu
function state_menu:transition ( i ) -- transition to state_menu v
	print "[state_menu] transition"
end
