-- xenjine layer 2  : p-shooter server tutorial
-- c2007 : lukas irwin : sysop [ at ] xhrit.com
-- pawn.lua

pawn = { ID = 0 }

-- print "[pawn]"

-- creation
function pawn:new (o)
	-- print "[pawn] new pawn"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	self.ID       = 0
	self.owner_ID  = 0
	self.type  = 0
	self.valid  = 0
	self.position = xcore.x3dpoint( 0, 0, 0 )
	self.lastPos = xcore.x3dpoint( 0, 0, 0 )
	self.rotation = xcore.x3dpoint( 0, 0, 0 )
	self.lastRot = xcore.x3dpoint( 0, 0, 0 )	
	self.delay       = 0
	self.lifespan = -1
	self.lifetime = 0
	self.remove = 0

	-- self.body = xcore.xbody()
	self.lastPoll = time:getTime()

	return o
end

function pawn:update ()
	-- print "[pawn] update"
	if self.delay > 0 then
		-- print ( "[pawn] action delay " .. self.delay )
		self.delay = self.delay - 1
	end
	
	self.lifetime = self.lifetime + 1

	if self.lifespan ~= -1 then 
		if self.lifetime > self.lifespan then
			-- print ( "[pawn] life " .. self.lifetime .." / " .. self.lifespan )
			self.remove = 1
		end
	end

	-- update ai ?
end

function pawn:setPosition ( p ) self.position = p end
function pawn:setLastPos ( p ) self.lastPos = p end

function pawn:getPosition () return self.body:getPosition() end

function pawn:setRotation ( r ) self.rotation = r end
function pawn:setLastRot ( p ) self.lastRot = p end
function pawn:getRotation () return self.body:getRotation() end

function pawn:setDelay ( d ) self.delay = d end
function pawn:getDelay () return self.delay end

function pawn:setID ( n ) self.ID = n end
function pawn:getID () return self.ID end

function pawn:getBody () return self.body end
function pawn:setBody ( b ) self.body = b end

function pawn:setOwner ( n ) self.owner_ID = n end
function pawn:getOwner () return self.owner_ID end

function pawn:setType ( n ) self.type = n end
function pawn:getType () return self.type end

function pawn:setLifeSpan ( n ) self.lifespan = n end
function pawn:getLifeSpan () return self.lifespan end

function pawn:setLifeTime ( n ) self.lifetime = n end
function pawn:getLifeTime () return self.lifetime end

function pawn:setRemove ( v ) self.remove = v end
function pawn:getRemove () return self.remove end

function pawn:setLastPoll ( n )
	-- self.lastPoll = n
end

function pawn:shouldPoll()
	-- print "[pawn] should poll"
	-- print ( "last poll at " .. self.lastPoll )
	-- print ( "current time is : " .. time:getTime() )
	b = false

	self.position = self:getPosition()
	self.rotation = self:getRotation()
	-- only poll if position or rotation has changed, and some time has passed.
	t = time:getTime() - self.lastPoll
	-- print ( t .. " elapsed")

	if t > 75 then 
		if math.abs ( self.lastPos.X - self.position.X ) > 2 then
			b = true
		elseif math.abs ( self.lastPos.Y - self.position.Y ) > 2 then
			b = true
		elseif math.abs ( self.lastPos.Z - self.position.Z ) > 2 then
			b = true
		end	

		if math.abs ( self.lastRot.X - self.rotation.X ) > 1 then
			b = true
		elseif math.abs ( self.lastRot.Y - self.rotation.Y ) > 1 then
			b = true
		elseif math.abs ( self.lastRot.Z - self.rotation.Z ) > 1 then
			b = true
		end	

	-- TODO: time specific to object type, so some objects poll more then others
	end

	-- TODO: only poll if physics are enabled?
	-- if self.body:getEnabled() == 1 then print "body is enabled" end

	if self.lifetime <= 1 then
		b = true
	end
	
	if b == true then self.lastPoll = time:getTime() end
	return b
end
