-- Xenos Engine Tutorial Graphics 1
-- c2007 lukas w irwin
-- tutorial_graphics_1.lua

-- required
function init()
	-- start a simulation
	sim = xcore.xsimulation ( xcore.XDT_OPENGL , 800, 600, 16, false, false, false )
	sim:setWindowCaption( "Xenos Engine Tutorial Graphics 1 : Basic 3d" )

	-- add a logo
	logo_texture = sim:getTexture( "modules/tutorial_graphics_1/resources/xenos_logo_small.tga" )
	logo_image = sim:addImage( 0, logo_texture, xcore.x2dpoint(-20, -10),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	
	-- add some static text describing the demo
	text = [[
	Xenos Engine Tutorial Graphics 1 : Basic 3d
	
	This demo will show you how to load a simple 3d model and a level mesh.
	Press escape to quit
	]]
	sim:addText( 0, text, 50, 50, 600, 600)

	-- add a static camera
	sim:addCamera ( 0, xcore.CAMERA_STATIC,-25,-60,-25, 25,-50, 25)

	-- create an animated 3d model
	mesh = sim:addMesh ( 0, "modules/tutorial_graphics_1/resources/faerie.md2" )
	mesh:addTexture ( "modules/tutorial_graphics_1/resources/faerie.bmp", 0 )
	mesh:setScale ( xcore.x3dpoint(1, 1, 1) )
	mesh:setMaterialFlag( xcore.XMF_LIGHTING, false )
	mesh:setMD2Animation( 0 )
	mesh:setAnimationSpeed( 10 )
	mesh:setPosition( xcore.x3dpoint( 25,-48, 25  ) )
	mesh:setRotation( xcore.x3dpoint( 0,180, 0  ) )
	
	-- add a .zip format Archive
	sim:addArchive( "modules/tutorial_graphics_1/resources/map-20kdm2.pk3" )
	
	-- create a 3d level mesh from the pk3(zip) file
	level_mesh = sim:addMesh ( 0, "20kdm2.bsp" )
	level_mesh:setMaterialFlag( xcore.XMF_LIGHTING, false )
	level_mesh:setPosition( xcore.x3dpoint( -1300,-144,-1249  ) )

	-- make it so you can exit the demo
	sim:bindkey ( "quit",  xcore.XKEY_ESCAPE  )

end

-- required
function render()
	-- render simulation tree
	sim:render()
end

-- required
function update()
	if sim:isKey( "quit" ) then sim:destroy() end
	sim:update()
end

-- end of file