-- Xenos Engine Tutorial Graphics 3 
-- c2007 lukas irwin sysop [ at ] xhrit.com
-- tutorial_graphics_2.lua

print "Xenos Engine Tutorial Graphics 2 ( User Inferface )"

-- new objects and methods for this tutorial
-- sim:getTexture
-- sim:makeColorKeyTexture
-- sim:draw2DImage
-- xcore.xtexture
-- xcore.xfont

-- Required start function. use to set up your program.
function init()
	-- start a simulation
	sim = xcore.xsimulation()
	sim:setWindowCaption( "Xenos Engine Tutorial Graphics 3 : Basic 2d" )

	-- add a logo
	logo_texture = sim:getTexture( "modules/tutorial_graphics_1/resources/xenos_logo_small.tga" )
	logo_image = sim:addImage( 0, logo_texture, xcore.x2dpoint(-20, -10),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	
	-- add some static text
	text = [[
	Xenos Engine Tutorial Graphics 2 ( User Inferface )
	
	This demo will show you how to display 2d images
	and textures, as well as fonts.
	]]
	sim:addText( 0, text, 20, 20, 800, 800)

	-- add the image
	images = sim:getTexture( "modules/tutorial_graphics_3/resources/2ddemo.bmp" )
	sim:makeColorKeyTexture( images, xcore.x2dpoint( 0, 0 ) )
	
	-- add some nice fonts
	font1 = sim:getBuiltInFont() -- built in font
	font2 = sim:getFont( "modules/tutorial_graphics_3/resources/fonthaettenschweiler.bmp" ) -- bmp font created using font tool ^^

	imp1 = xcore.x2drect(349,15,385,78)
	imp2 = xcore.x2drect(387,15,423,78)

	-- set time to zero
	time = 0
	
	-- make it so you can exit the demo
	sim:bindkey ( "quit",  xcore.XKEY_ESCAPE  )	
end

-- Render function; required.
function render()
	-- render.
	sim:prerender()

	-- draw fire & dragons background world
	sim:draw2DImage(images, xcore.x2dpoint( 50, 50 ), xcore.x2drect( 0, 0, 342, 224 ), xcore.xcolour( 255, 255, 255, 255 ) )

	-- draw flying imp
	if time == 0 then
		i = imp1
		time = 1
	else
		i = imp2
		time = 0
	end

	sim:draw2DImage(images, xcore.x2dpoint( 164, 125 ), i, xcore.xcolour(255,255,255,255))

	-- draw second flying imp with colorcylce
	sim:draw2DImage(images, xcore.x2dpoint( 270, 105 ), i, xcore.xcolour(255,255,255,255))

	-- draw some text
	font1:draw("This is some text.", xcore.x2drect( 130,210,300,250 ), xcore.xcolour( 255, 255, 255, 255 ) )

	-- draw some other text
	font2:draw("This is some other text.", xcore.x2drect( 130, 220, 300, 260 ), xcore.xcolour( 255,time % 255,time % 255,255 ) )

	-- render.
	sim:postrender()
end

-- Thei is required
function update()
	sim:update()
	
	if sim:isKey( "quit" ) then sim:destroy() end
end

-- end of file